// OCR engine (c) Joerg Schulenburg
//
/*
This is a Optical-Character-Recognition program
Copyright (C) 2000  Joerg Schulenburg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 Joerg.Schulenburg@physik.uni-magdeburg.de

*/

#include "pgm2asc.h"
#include "stdlib.h"
#include "stdio.h"

// OCR engine ;)
char ocr0(struct box *box1,
          int x0, int x1, int y0, int y1, // box-frame in p
          pix  p, pix  b, int cs, int dots){

   int	d,x,y;
   int  dx=x1-x0+1,dy=y1-y0+1;	// size
   char	bc='_';				// bestletter
   char um=' ';				// umlaut? '"
   int hchar;		// char is higher than 'e'
   int gchar;		// char has ink lower than m3
   // --- test thin lines - ---------------------------------
   for( ; 2*dy<box1->m3-box1->m2 && dx>=2*dy && dx>4; ){     // max 3x3 (small font)
      if( get_bw(x0+dx/10,x1-dx/10,y0+dy/2,y0+dy/2,p,cs,2)==2 ) break;
      if( dots ) return '=';
      return '-';
   }
   // --- test thin lines = ---------------------------------
   for( ; dy>2 && dx>4; ){     // max 3x3 (small font)
      if( get_bw(x0+dx/10,x1-dx/10,y0     ,y0     ,p,cs,2)==2 ) break;
      if( get_bw(x0      ,x1      ,y0+dy/2,y0+dy/2,p,cs,1)==1 ) break;
      if( get_bw(x0+dx/10,x1-dx/10,y1     ,y1     ,p,cs,2)==2 ) break;
      return '=';
   }
   // --- test dots : ---------------------------------
   for( ; dy>5 && dx>3 && dy>=3*dx; ){     // max 3x3 (small font)
      if( get_bw(x0+dx/10,x1-dx/10,y0+dx/2,y0+dx/2,p,cs,2)==2 ) break;
      if( get_bw(x0      ,x1      ,y0+dx+1,y1-dx-1,p,cs,1)==1 ) break;
      if( get_bw(x0+dx/10,x1-dx/10,y1-dx/2,y1-dx/2,p,cs,2)==2 ) break;
      return ':';
   }
   // --- test dots ; ---------------------------------
   for( ; dy>5 && dx>3 && dy>3*dx; ){     // max 3x3 (small font)
      int i;
      for( i=1+dy/14,y=y0;y<y0+dy/3 && i;y++)
        if( get_bw(x0+dx/7,x1-dx/10,y,y,p,cs,2)==2 ) i--;
      if( i ) break;
      if( get_bw(x0,x1,y0+dy/3,y0+dy/3,p,cs,1)==1 ) break;
      if( get_bw(x1,x1,y1     ,y1     ,p,cs,1)==1 && dx>4 ) break;
      for( i=1+dy/20,y=y0+dy/3;y<y1-dy/5 && i;y++)
        if( get_bw(x0+dx/7,x1-dx/10,y,y,p,cs,2)==2 ) i--;
      if( i ) break;
      for( i=1,y=y1-dy/5;y<=y1 && i;y++)
        if( loop(p,x0,y,dx,cs,0,RI)
          + loop(p,x1,y,dx,cs,0,LE) < dx/2 ) i=0;
      if( !i ) break;
      return ';';
   }
   // --- first test small dots . ---------------------------------
   if( 3*dy<box1->m4-box1->m1 && abs(dx-dy)<2 && y1+1>=box1->m3 ){ return '.'; }
   // --- first test small dots , ---------------------------------
   if( 2*dy<box1->m4-box1->m1 && dx<dy && 2*y0>box1->m2+box1->m3 ){ return ','; }
   // --- first test small dots ' ---------------------------------
   if( 2*dy<box1->m4-box1->m1 && dx<dy && 2*y1<box1->m2+box1->m3 ){ return '\''; }
//   if( dots==1 ){ um='\''; }
#if 1
   if( dots==0 ){ // i-dots ???
      y=box1->m1;
      for(;y<y0+dy/2;y++)if( get_bw(x0+dx/4,x1,y,y,p,cs,1)==1) break;
      {
        if( y<y0+dy/2 )
        for(;y<y0+dy/2;y++)if( get_bw(x0,x1,y,y,p,cs,1)==0) break;
        if( y<y0+dy/2 ){ dots=1;um='\'';
          if( get_bw((x0+x1)/2,(x0+x1)/2,box1->m1,box1->m2-1,p,cs,1)==0)
          if( get_bw( x0      ,(x0+x1)/2,box1->m1,box1->m2-1,p,cs,1)==1)
          if( get_bw((x0+x1)/2,    x1   ,box1->m1,box1->m2-1,p,cs,1)==1)
          { dots=2; um='\"'; }
        }
      }
   }
#endif
   if( um=='\'' || um=='\"'){
      for(y=y1;y>y0;y--)
      if( get_bw(x0,x1,y,y,p,cs,1)==0) { y0=y; dy=y1-y0+1; break; } // scan "a "o "u
   }
   // --- hchar --- gchar -------------------------
   hchar=0;if( 2*y0<=2*box1->m2-(box1->m2-box1->m1) ) hchar=1;
   gchar=0;if( 2*y1>=2*box1->m3+(box1->m4-box1->m3) ) gchar=1;

   // --- most frequent letter 'e' first!!!
   // --- test e ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i,j;
      if( loop(p,x0,y0+dy/2,x1-x0,cs,0,RI)>dx/3 ) break; // rough test
      if( loop(p,x0+dx/2,y0,y1-y0,cs,0,DO)>dy/3 ) break;
      if( loop(p,x0+dx/2,y1,y1-y0,cs,0,UP)>dy/3 ) break;
      i=loop(p,x0,y0+dy/2,x1-x0,cs,0,RI); if( i>dx/2 ) break;
      j=loop(p,x0,y0     ,x1-x0,cs,0,RI); if( j<i    ) break;
      j=loop(p,x0,y1     ,x1-x0,cs,0,RI); if( j<i    ) break;
      i=loop(p,x0+dx/2,y0,y1-y0,cs,0,DO); if( i>dx/2 ) break;
      j=loop(p,x1-dx/3,y0,y1-y0,cs,0,DO); if( j<i ) i=j;
      j=loop(p,x0     ,y0,y1-y0,cs,0,DO); if( j<i    ) break;
      j=loop(p,x1     ,y0,y1-y0,cs,0,DO); if( j<i    ) break;
      i=loop(p,x0+dx/2,y1,y1-y0,cs,0,UP); if( i>dx/2 ) break;
      j=loop(p,x0     ,y1,y1-y0,cs,0,UP); if( j<i    ) break;
      j=loop(p,x1     ,y1,y1-y0,cs,0,UP); if( j<i    ) break;
      for(i=1,j=x0+dx/6;j<=x1-dx/6 && i;j++)
        if( num_cross(j,j,y0,y1,p,cs) == 3 ) i=0;
      if( i ) break;
      // suche Horizontalen Teiler
      for(x=0,y=i=y0+dy/3;i<y1-dy/6;i++){
        j=loop(p,x1,i,y1-y0,cs,0,LE);
        if(j>=x) { x=j;y=i; }
      }
      if (x<dx/2) break;
      for(i=1,j=x0+dx/6;j<x1-dx/6 && i;j++)
        if( num_cross(j,j,y0,y,p,cs) > 1 ) i=0;
      if( i ) break;
      if( num_cross(x0,x1,y,y,p,cs) != 1 ) break; // ausser bei weit geschwungenem e
      if( num_hole(x0, x1, y0 , y  ,p,cs) <  1 ) break;
      if( num_hole(x0, x1, y+1, y1 ,p,cs) != 0 ) break;
      // suche Horizontalen Teiler
      for(x=0,y=i=y0;i<y1;i++){
        j=loop(p,x0,i,y1-y0,cs,0,RI);
        if(j>=x) { x=j;y=i; }
      }
      if (y>y0+dy/6 && y<y1-dy/8) break;
      if( num_cross(x0+dx/2,x1,y1-dy/4,y1,p,cs) == 0 ) break; // ~p
     return 'e';
   }
   // --- test f like t ---------------------------------------------------
   if( (!dots) )  // Bold-face is gchar
   for(d=100;dx>2 && dy>box1->m3-box1->m2+2;){     // sometimes no hchar! 
      int i,j;
      for(x=0,j=y=2+(3*dy+8)/32;y<4*dy/8;y++){ // upper cross line
        i=loop(b,0,y,dx,cs,0,RI); if( y>dy/4 && i>dx/2 ) break;
        i=loop(b,i,y,dx,cs,1,RI); if( i>x ) { x=i;j=y; }
        if( y<3*dy/4 && y>dy/4
         && num_cross(0,dx-1,y  ,y  ,b,cs) != 1
         && num_cross(0,dx-1,y+1,y+1,b,cs) != 1  // against noise
          ) break;
      } if( y<4*dy/8 ) break; y=j;// if( y>dy/2 || y<dy/8 ) break;
       
      i=loop(b,0,dy/2,dx,cs,0,RI);
      i=loop(b,i,dy/2,dx,cs,1,RI); // thickness
      if( x<2*i ) break;

      if( loop(b,dx-1,dy/2,dx,cs,0,LE)-1
        <=loop(b,dx-1, y  ,dx,cs,0,LE) ) break; // ~1

      if( loop(b,0,dy/2,dx,cs,0,RI)-1
         >loop(b,0,   1,dx,cs,0,RI) ) break; // ~X

      i=y;j=1;
      for(y=1;j && y<i;   y++)  // no @@ pattern
      for(x=0;j && x<dx-2;x++){ //    ..
        if(  pixel(b,x  ,y  )>=cs && pixel(b,x+1,y  )>=cs
          && pixel(b,x  ,y-1)< cs && pixel(b,x+1,y-1)< cs ) { j=0;break; }
      }  if(j) break;

      if( num_hole (x0  , x1  , y0, y1,p,cs) != 0 ) break; // ~e 
      // out_b(p,x0,y0,dx,dy,cs); printf(" out_t xyi %d %d %d %d\n",x,y,i,j);

      return 'f';
   }
#if 1
   // --- test E ---------------------------------------------------
   for(d=100;dx>2 && dy>4 ;){     // min 3x4
      int i,j;
      // Hohlraeume rechts offen?
      for( i=1,y=y0; y<y0+dy/4 && i; y++ ) // long black line
        if( get_bw(x0+dx/3,x1-dx/6,y,y,p,cs,2) == 0 ) i=0;
      if( i ) break;
      for( i=1,y=y1; y>y1-dy/4 && i; y-- ) // long black line
        if( get_bw(x0+dx/6,x1-dx/4,y,y,p,cs,2) == 0 ) i=0;
      if( i ) break;
      for( i=1,y=y0+dy/3; y<y1-dy/3 && i; y++ ){ // black line
        j=loop(p,x0  ,y,dx,cs,0,RI);
        j=loop(p,x0+j,y,dx,cs,1,RI); if( j>dx/3 ) i=0;
      } if( i ) break;
      x=x1-dx/3; y=y0;		// von oben durchbohren!
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,ST); if( y>y0+dy/4 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,DO); if( y>y0+dy/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,DO); if( x<=x1 || y>y0+dy/2 ) break;
      x=x1-dx/3; y=y1;		// von unten durchbohren!
      turmite(p,x,y,x0,x1,y0,y1,cs,UP,ST); if( y<y1-dy/4 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,UP); if( y<y0-dy/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,UP); if( x<=x1 || y<y0+dy/2 ) break;
      x=x1-dx/3; y=y0;		// von oben durchbohren!
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,ST); if( y>y0+dy/4 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,DO); if( y>y0+dy/3 ) break;
      y+=dy/15;
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST); if( x<=x0 ) break;
      x+=dx/15+1;
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,ST); if( y>y1-dy/3 ) break;
      if( num_hole(x0, x1, y0 , y1  ,p,cs) > 0 ) break;
      i=loop(p,x0,y0+dy/4,dx,cs,0,RI); if(i>dx/2) break;
      j=loop(p,x0,y0+dy/2,dx,cs,0,RI); if(j<i-dx/4 || j>i+dx/8) break; i=j;
      j=loop(p,x0,y1-dy/4,dx,cs,0,RI); if(j<i-dx/4 || j>i+dx/8) break;
      for( x=dx,y=y0+dy/6; y<y1-dy/9; y++ ) // left border straight
      { i=loop(p,x0,y,dx,cs,0,RI); if( i>x+dx/9 ) break;
        if(i<x) x=i;
      } if( y<y1-dy/9 ) break;	// t
     return 'E';
   }
   // --- test w -------
   for(d=100;dx>4 && dy>3;){     // dy<=dx
      int i,i1,i2,i3,i4;
      if( loop(b,0    ,b.y/4,dx,cs,0,RI) >
          loop(b,0    ,b.y-1,dx,cs,0,RI)   ) break;
      if( loop(b,b.x-1,b.y/4,dx,cs,0,LE) >
          loop(b,b.x-1,b.y-1,dx,cs,0,LE)+1 ) break;
      for( i3=y=0,i1=x=x0;x< x0+dx/2;x++ ){ // suche erstes V
        i=loop(p,x,y0,dy,cs,0,DO);
        if( i>y ) { i3=y=i;i1=x; }
      } i3+=y0-1; if( i3<y0+dy/3 ) break;
      for( i4=y=0,i2=x=x1;x>=x0+dx/2;x-- ){ // suche zweites V
        i=loop(p,x,y0,dy,cs,0,DO);
        if( i>y ) { i4=y=i;i2=x; }
      } i4+=y0-1; if( i4<y0+dy/3 ) break;
      if( get_bw(i1,i2,i3,i3,p,cs,1) != 1 ) break;
      if( get_bw(i1,i2,i4,i4,p,cs,1) != 1 ) break;
      if( get_bw(x0,i1,i3,i3,p,cs,1) != 1 ) break;
      if( get_bw(i2,x1,i4,i4,p,cs,1) != 1 ) break;
      for ( y=y1; y>y0+dy/2; y-- )
      if( num_cross( x0, x1, y , y ,p,cs) == 2 ) break;
      if( loop(p,x1,y      ,dx,cs,0,LE)		// ur-duo
        <=loop(p,x1,y0+dy/2,dx,cs,0,LE) ) break;
      if( hchar ) return 'W';
      return 'w';
   }
   // --- test A ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i1,i2,i3,i4;

      for(y=dy/8;y<dy/2;y++) if( num_cross(0,dx-1,y,y,b,cs) > 1 ) break;
      if( y==dy/2 ) break; i1=y;
      x =loop(b,0,i1,dx,cs,0,RI); if(x>3*dx/4) break;
      x+=loop(b,x,i1,dx,cs,1,RI); if(x>3*dx/4) break; i2=x;
      x+=loop(b,x,i1,dx,cs,0,RI); if(x<3*dx/8) break; i2=(x+i2)/2;
      // hole (i2,i1)
      y+=loop(b,i2,y,dy,cs,0,DO); if(y>3*dy/4) break;
      
      if( num_hole ( x0, x1, y0, y1-dy/4 ,p,cs) != 1 ) break;
      i3=0;
      for(x=dx/4;x<3*dx/4;x++){
       i4=num_cross(i2,x,y,dy-1,b,cs);if(i4<1 || i4>2) break;
       if(i4==1) i3=x;
      } if(i4<1 || i4>2 || i3==0) break;

      if( get_bw(   0     , dx/4, dy-1-dy/4, dy-1, b,cs,1) != 1 ) break;
      if( get_bw(dx-1-dx/4, dx-1, dy-1-dy/4, dy-1, b,cs,1) != 1 ) break;
      if( get_bw(   0     , dx/8,        0 , dy/4, b,cs,3) != 2 ) break;
      if( get_bw(dx-1-dx/8, dx-1,        0 , dy/4, b,cs,3) != 2 ) break;

      if( num_cross( 0, dx-1, dy-1 , dy-1 ,b,cs) != 2
       && num_cross( 0, dx-1, dy-2 , dy-2 ,b,cs) != 2 ) break;
      if( num_cross( 0, dx-1,    0 ,    0 ,b,cs) != 1 
       && num_cross( 0, dx-1,    1 ,    1 ,b,cs) != 1 ) break;

      i1=loop(b,dx-1,     dy/4,dx,cs,0,LE);
      i2=loop(b,dx-1,     dy/2,dx,cs,0,LE);
      i3=loop(b,dx-1,dy-1-dy/4,dx,cs,0,LE);
      if( 2*i2+dx/4<i1+i3 || 2*i2-dx/8>i1+i3 ) break;
      i1=loop(b,0   ,     dy/4,dx,cs,0,RI);	// linke senkr. linie
      i2=loop(b,0   ,     dy/2,dx,cs,0,RI);
      i3=loop(b,0   ,dy-1-dy/4,dx,cs,0,RI);
      if( 2*i2+dx/4<i1+i3 || 2*i2-dx/8>i1+i3 || i1<i3) break;

      for(i3=dx,y=dy/4;y<15*dy/16;y++){ // increasing width
        i1=loop(b,   0, y,dx,cs,0,RI);
        i2=loop(b,dx-1, y,dx,cs,0,LE);
        if(i1+i2>i3) break; i3=i1+i2;
      } if(y<15*dy/16) break;       

      bc='A';
      if(um=='\"') bc=196;
      break;
   }
   // --- test a ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i;
      if( get_bw(x0     , x0+dx/2, y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3, x1     , y0+dy/3, y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3, x1     , y0+dy/4, y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2, y1-dy/2, y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2, y0     , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/3, x1-dx/3, y0     , y0     ,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/4, x1-dx/2, y1     , y1     ,p,cs,1) != 1 )
      if( get_bw(x0+dx/4, x1-dx/3, y1-1   , y1-1   ,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0     , y0+dy/2, y1     ,p,cs,1) != 1 )
      if( get_bw(x0+dx/8, x0+dx/8, y0+dy/2, y1     ,p,cs,1) != 1 ) break;

      for(i=dx/8+1,x=dx/4;x<=dx-1-dx/4 && i;x++){
        if( num_cross(x,x,0,b.y-1, b,cs) == 3 ) i--;
      } if( i ) break;

      if( num_hole (x0     , x1     , y0+dy/3, y1 ,p,cs) != 1 ) break;
      if( num_hole (x0     , x1     , y0     , y1 ,p,cs) != 1 ) break;
      if( num_hole (x0     , x1     , y0, y1-dy/3 ,p,cs) != 0 ) break;
      bc='a';
      if(um=='\"') bc=228;
      break;
   }
   // --- test schreib a ---------------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      int i;
      if( get_bw(x0      , x0+dx/2,y0+dy/2 , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/2 , x1     ,y0+dy/2 , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y1-dy/2 , y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y0      , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y0+dy/2 , y1-dy/3,p,cs,3) != 2 ) break;

      if( num_cross(x0+dx/2,x0+dx/2,y0      , y1     ,p,cs)  != 2 ) break;
      if( num_cross(x0+dx/3,x1-dx/3,y0      , y0     ,p,cs)  != 1 ) // AND
      if( num_cross(x0+dx/3,x1-dx/3,y0+1    , y0+1   ,p,cs)  != 1 ) break;

      if( num_cross(x0,x1,y1      , y1     ,p,cs)  != 2 )
      if( num_cross(x0,x1,y1-1    , y1-1   ,p,cs)  != 2 ) break;

      if( num_cross(x0     ,x0     ,y0+dy/3 , y1-dy/3,p,cs)  != 1 )
      if( num_cross(x0+1   ,x0+1   ,y0+dy/3 , y1-dy/3,p,cs)  != 1 ) break;
      if( num_hole(x0,x1,y0     ,y1     ,p,cs) != 1 ) break;
      if( num_hole(x0,x1,y0+dy/4,y1     ,p,cs) != 0 ) break;
      if( num_hole(x0,x1,y0     ,y1-dy/5,p,cs) != 0 ) break; // Q

//      out_b(b,0,0,dx,dy,cs);
      if( loop(b,0   ,0   ,x1-x0,cs,0,RI)<=
          loop(b,0   ,2   ,x1-x0,cs,0,RI)  ) break;

      x=loop(b,dx-1,b.y-1-b.y/3,x1-x0,cs,0,LE);	// should be minimum
      for( y=b.y-1-b.y/3;y<b.y;y++ ){
        i=loop(b,dx-1,y,x1-x0,cs,0,LE);
        if( i<x ) break; x=i;
      }
      if( y>=b.y ) break;
      bc='a';			// schreib-a (alpha)
      if(um=='\"') bc=228;
      break;
   }
   // --- test c,C ---------------------------------------------------
   if(!gchar)
   for(d=100;dx>2 && dy>2;){     // min 3x4
      int i,i1,i2,i3;
      if( get_bw(x0     , x0+dx/3,y0+dy/2, y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2,y1-dy/3, y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2,y0     , y0+dy/3,p,cs,1) != 1 ) break;
      for(y=y0+dy/4;y<y0+3*dy/4;y++)
      if( get_bw(x0+dx/2, x1     ,y      , y      ,p,cs,1) != 1 ) break;
      if( y==y0+3*dy/4 ) break; i1=y;
      i2=y-1+loop(p,x0+dx/2,i1,dy,cs,0,DO); if(i2<y0+3*dy/4) break; // lowest 
      i3=y+1-loop(p,x0+dx/2,i1,dy,cs,0,UP); if(i3>y0+  dy/4) break; // highest
      if( num_cross(x0+dx/2,x1,i2,y0,p,cs) < 1 ) break; // ~L
      if( num_cross(x0+dx/2,x1,i3,y1,p,cs) < 1 ) break; // ~r
      
      i=1;
      for(x=dx/2;x<dx-1 && i;x++)  // look for  @@ (instead +1 use +delta?) 
      for(y=dy/2;y<dy-1 && i;y++){ //           .@
        if( pixel(b,x  ,y  )>=cs
        &&  pixel(b,x+1,y  )< cs
        &&  pixel(b,x+1,y-1)< cs
        &&  pixel(b,x  ,y-1)< cs ) { i=0;break; }
      }
//      out_b(b,0,0,dx,dy,cs); printf(" ok? %d\n",i);

      if(!i) break;

      bc='c'; if( hchar ) bc='C';
      return bc;
   }
   // --- test uU ---------------------------------------------------
   //  in Mitte so breit wie oben (bei V kontinuierlich schmaler)
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      if( num_cross(x0,x1,y0+dy/2,y0+dy/2,p,cs) < 2 ) break;
      for(i=dy/10+1,y=y0+dy/4;y<=y1-dy/4 && i;y++){	// 12%+1 Fehler
        if( num_cross(x0     ,x0+dx/2,y,y,p,cs) != 1 ) i--;
      } if( !i ) break;
      for(i=dy/10+1,y=y0+dy/8;y<y1-dy/4 && i;y++){	// 12%+1 Fehler
        if( num_cross(x1-dx/2,x1     ,y,y,p,cs) != 1 ) i--;
      } if( !i ) break;
      for(i=1,x=x0+dx/3;x<=x1-dx/3 && i;x++){
        if( get_bw( x, x, y0,    y0+dy/3,p,cs,1) != 1 ) i=0;
      } if( i ) break;
      for(i=dx/4+1,x=x0+dx/3;x<=x1-dx/3 && i;x++){
        if( get_bw( x, x,y0+dy/3,y1-dy/3,p,cs,3) != 2 ) i--;
      } if( !i ) break;
      for(i=1,x=x0+dx/3;x<=x1-dx/3 && i;x++){
        if( get_bw( x, x,y1-dy/3,     y1,p,cs,3) == 2 ) i=0;
      } if( !i ) break;

      bc='u';
      if(um=='\"') bc=252;    // unknown
      if(dots==0) if( hchar )
      /* if(um=='\"') bc=220; else */ bc='U';
      break;
   }
   // --- test v -------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      if( get_bw(x0     , x0+dx/2,y0+dy/2, y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/2, x1     ,y0+dy/2, y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2,y1-dy/2, y1,     p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/2, x1-dx/2,y0     , y0+dy/3,p,cs,3) != 2 ) break;

      if(b.p[dx/2+(dy/3)*b.x]<cs) break; // empty centre
      // UVW
      if( (num_cross(0,dx-1,     dy/8,     dy/8,b,cs)==2) )
      if( (num_cross(0,dx-1,dy-1-dy/8,dy-1-dy/8,b,cs)==3) ) break;
      // UV
      if( get_bw(0        ,dx/8,dy-1-dy/6,dy-1,b,cs,1)==1 ) break;
      if( get_bw(dx-1-dx/8,dx-1,dy-1-dy/6,dy-1,b,cs,1)==1 ) break;
      if( loop(b,0   ,dy/6     ,dx,cs,0,RI)
        >=loop(b,0   ,dy-1-dy/3,dx,cs,0,RI) ) break;
      if( loop(b,0   ,dy-1-dy/3,dx,cs,0,RI)
        >=loop(b,0   ,dy-1-dy/8,dx,cs,0,RI)
       && loop(b,dx-1,dy-1-dy/3,dx,cs,0,LE)
        >=loop(b,dx-1,dy-1-dy/8,dx,cs,0,LE) ) break;
      if( loop(b,dx-1,dy/6     ,dx,cs,0,LE)
        >=loop(b,dx-1,dy-1-dy/3,dx,cs,0,LE) ) break;
      x=loop(b,0,dy-1,dx,cs,0,RI);
      x=loop(b,x,dy-1,dx,cs,1,RI); if ( dx>14 && 3*x>dx ) break; // U
      bc='v';
      if( hchar ) bc='V';
      break;
   }
   // --- test r -------
   for(d=100;dy>4 && dx>2;){     // dy>dx
      int i,i1,i2;
      if( dots || hchar || gchar || 2*dy<box1->m3-box1->m1) break;

      i=dy-(dy+20)/32;	// ignore dust on the ground

      for( y=4*dy/8; y<i; y++ ){  // center down v-line
        if( y<dy-2*dy/8 && num_cross(0,dx-1,y,y,b,cs) !=1 ) break;
        i1= loop(b,0   ,y,dx,cs,0,RI); if(i1>3*dx/8) break;
        i2= loop(b,dx-1,y,dx,cs,0,LE); if(i1>i2) break;
        if( (i1+(dx-i2-1))/2 >= 4*dx/8 ) break; // mass middle should be left
      }
      if (y<i) break;

      for( x=4*dx/8; x<dx; x++ ){  // right upper h-line
        if( get_bw(x,x,0,dy/4,b,cs,1) !=1 ) break; }
      if (x<dx) break;

      if( loop(b,dx-1,dy-1-dy/4,dx,cs,0,LE)>5*dx/8          // not a C
      && get_bw(dx-1-dx/8,dx-1,dy-1-dy/4,dy-1,b,cs,1) ==1 ) break;

      if( loop(b,0,dy/4,dx,cs,0,RI)>3*dx/8          // not a I
      && get_bw(0,dx/8,0,dy/4,b,cs,1) ==1 ) break;
      if( num_hole(x0, x1, y0 , y1 ,p,cs) != 0 ) break; // not \sc P

      return 'r';
   }
   // --- test R ---------------------------------------------------
   if(!gchar)
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      for(i=1,y=y0+dy/8;y<=y1-dy/8 && i;y++){  // left v-line
        if( get_bw(x0     , x0+dx/2,y, y,p,cs,1) != 1 ) i=0;
      } if( !i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){  // upper h-line
        if( get_bw( x, x, y0,    y0+dy/4,p,cs,1) != 1 ) i=0;
      } if( !i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){  // lower h-gap
        if( get_bw( x, x,y1-dy/4,y1     ,p,cs,3) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/3;x<=x1-dx/8 && i;x++){  // vert crossed 2 ???
        if( num_cross(x,x,y0,y1, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y0;y<=y0+dy/4 && i;y++){  // upper 2 vert lines
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y0+dy/3;y<=y1-dy/3 && i;y++){ // midle h line
        if( num_cross(x0,x1,y,y, p,cs) == 1 ) i=0;
      } if( i ) break;
      for(i=1,y=y1-dy/4;y<=y1 && i;y++){   // lower 2 vert lies
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      if( get_bw(x1-dx/3,x1,y0,y0+dy/4,p,cs,1) != 1 ) break; // pixel ru
      x=loop(b,dx-1,     dy/4,dx,cs,0,LE); if(x>dx/2) break; i=x; // ru
      x=loop(b,dx-1,     dy/2,dx,cs,0,LE); if(x<=i  ) break; i=x; // rc
      x=loop(b,dx-1,dy-1-dy/8,dx,cs,0,LE); if(x>=i  ) break;      // rd
      if( num_hole(x0, x1, y0 , y1-dy/3 ,p,cs) != 1 ) break;
      bc='R'; break;
   }
   // --- test m -------
   if(!gchar && !hchar)
   for(d=100;dx>4 && dy>3;){
      int i1,i2,i3,i4;
      y=dy/2;
      if( num_cross(0,dx-1,y  ,y  ,b,cs) != 3
       && num_cross(0,dx-1,y+1,y+1,b,cs) != 3 ) break; // m ru rn
      x =loop(b,0,y,dx  ,cs,0,RI); if(x>  dx/4) break; // search 1st v-line
      x+=loop(b,x,y,dx-x,cs,1,RI); if(x>  dx/2) break; i1=x; // first gap
      x+=loop(b,x,y,dx-x,cs,0,RI); if(x>3*dx/4) break; i2=x; // 2nd v-line
      x+=loop(b,x,y,dx-x,cs,1,RI); if(x>6*dx/8) break; i3=x; // 2nd gap
      x+=loop(b,x,y,dx-x,cs,0,RI); if(x<5*dx/8) break; i4=x; // 3th v-line
      if( abs((i2-i1)-(i4-i3)) > 2+((i2-i1)+(i4-i3))/16 ) break; // same gap width? rn
      // the same game for the lower part =>l1 l2 l3 l4 ???
      for(x=i1;x<i4;x++) if( loop(b,x,0,dy,cs,0,DO)>=dy/4 ) break;
      if(x<i4) break; // gap detected
      for(x=i1;x<i2;x++) if( loop(b,x,dy-1,dy,cs,0,UP)>dy/4 ) break;
      if(x==i2) break; // no gap detected
      for(x=i3;x<i4;x++) if( loop(b,x,dy-1,dy,cs,0,UP)>dy/4 ) break;
      if(x==i4) break; // no gap detected
      for(x=i1;x<i3;x++) if( loop(b,x,dy-2,dy,cs,1,UP)>dy/4 ) break;
      if(x==i3) break; // no middle line detected

//      out_b(p,x0,y0,dx,dy,cs);
//      if( i3<=y0+dy/3 )
//      if( i4<=y0+dy/3 )
      return 'm';

   }
   // --- test M -------
   if((!gchar)/* && hchar */)  // SMALL CAPS FONT ???
   for(d=100;dx>4 && dy>3;){	// dy<=dx nicht perfekt! besser mittleres
				// min-suchen fuer m
      int i1,i2,i3;
      y=dy/2;
      if( num_cross(0,dx-1,y  ,y  ,b,cs)<3
       && num_cross(0,dx-1,y-1,y-1,b,cs)<3 ) break;
      // width>dx/2
      for(y=1;y<dy-1;y++)
      if( loop(b,0   ,y,dx,cs,0,RI)
         +loop(b,dx-1,y,dx,cs,0,LE) >4*dx/8 ) break;
      if( y<dy-1 ) break;
      // MNWK
      for(i2=0,i1=x=dx/2;x<dx-dx/4;x++){ // lowest pixel
        y=loop(b,x,0,dy,cs,0,DO); if(y>i2) {i2=y;i1=x;} else break; }
      i3=i2+loop(b,i1,i2,dy-i2,cs,1,DO);
      if(i2<dy/4) break;	// rm

      if( num_cross(i1,dx-1,i2-1,i2-1,b,cs)!=2
       || num_cross(0 ,i1  ,i2-1,i2-1,b,cs)!=2 ) break;  // too hard ???
      return 'M';
   }
   // --- test n ---------------------------------------------------
   if(!hchar && !gchar)
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i1,i2,i3;
      y=7*dy/8;
      if( num_cross(   0,dx/2,y  ,y  ,b,cs) != 1
       && num_cross(   0,dx/2,y-1,y-1,b,cs) != 1
       && num_cross(dx/2,dx-1,y  ,y  ,b,cs) <  1 ) break; // n rr
      y=dy/2;
      if( num_cross(0,dx-1,y  ,y  ,b,cs) != 2
       && num_cross(0,dx-1,y+1,y+1,b,cs) != 2 ) break; // n rr
      
      x =loop(b,0,y,dx  ,cs,0,RI); if(x>  dx/4) break; // search 1st v-line
      x+=loop(b,x,y,dx-x,cs,1,RI); if(x>  dx/2) break; i1=x; // 1st gap
      x+=loop(b,x,y,dx-x,cs,0,RI); if(x<  dx/2) break; i2=x; // 2nd v-line
      x+=loop(b,x,y,dx-x,cs,1,RI); if(x<3*dx/4) break; i3=x; // 2nd gap

      // the same game for the lower part =>l1 l2 l3 l4 ???
      for(x=i1;x<i2;x++) if( loop(b,x,   0,dy,cs,0,DO)>=dy/4 ) break;
      if(x <i2) break; // gap detected
      for(x=i1;x<i2;x++) if( loop(b,x,dy-1,dy,cs,0,UP) >dy/4 ) break;
      if(x==i2) break; // no gap detected

//      out_b(p,x0,y0,dx,dy,cs); printf(" i= %d %d %d\n",i1,i2,i3);

      return 'n';
   }
   // --- test N ------- +hchar -gchar
   if(hchar && !gchar)
   for(d=100;dx>3 && dy>3;){	// dy<=dx nicht perfekt! besser mittleres
      int i,i1,i2,i3,i4;
      if( num_cross(0,dx-1,dy/2,dy/2,b,cs) != 3 ) break;
      for( i3=y=0,i1=x=x0+dx/5;x< x1-dx/3;x++ ){ // suche erstes ^
        i=loop(p,x,y1,dy,cs,0,UP);
        if( i>y ) { i3=y=i;i1=x; }
      } i3=y1-i3+1; if( i3>y1-dy/4 ) break;
      for( i4=y=0,i2=x=x0+dx/3;x< x1-dx/5;x++ ){ // suche zweites v
        i=loop(p,x,y0,dy,cs,0,DO);
        if( i>y ) { i4=y=i;i2=x; }
      } i4=y0+i4-1; if( i4<y0+dy/4 ) break;
      if( num_cross(i1,x1,i3,i3,p,cs) != 2 ) break;
      if( num_cross(x0,i1,i3,i3,p,cs) != 1 ) break;
      if( num_cross(i2,x1,i4,i4,p,cs) != 1 ) break;
      if( num_cross(x0,i2,i4,i4,p,cs) != 2 ) break;
      for( i=x=0,y=y0+3*dy/8; y<y1-dy/4; y++ ){	// hl-duo
        i =loop(p,x0  ,y,dx,cs,0,RI);
        i+=loop(p,x0+i,y,dx,cs,1,RI);	// 1st line
        i =loop(p,x0+i,y,dx,cs,0,RI);	// growing gap?
        if( i+1<x ) break; if(i>x) x=i; // one pixel tolerance
      } if( i+1<x ) break;
      return 'N';
   }
   // --- test h ---------------------------------------------------
   if(hchar && (!gchar))  
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      if( get_bw(0        ,dx/2,dy/2     ,dy/2     ,b,cs,1) != 1 ) break;
      if( get_bw(dx/2     ,dx-1,dy-1-dy/3,dy-1-dy/3,b,cs,1) != 1 ) break;
      if( get_bw(dx/2     ,dx/2,dy/5     ,dy-1-dy/3,b,cs,1) != 1 ) break;
      if( get_bw(dx-1-dx/3,dx-1,0        ,dy/5     ,b,cs,1) == 1 ) break;
      for( x=x0+dx/3;x<x1-dx/3;x++)
      if( get_bw(x, x,y1-dy/3, y1,     p,cs,1) == 0 ) break;
      if( x>=x1-dx/3 ) break;
      for(i=dy/4,y=y0+dy/3;y<=y1 && i;y++){
        if( num_cross(x0,x1     ,y,y, p,cs) == 2 ) i--;
      } if( i ) break;
      for(i=dy/4,y=y0;y<=y0+dy/2 && i;y++){
        if( num_cross(x0,x0+dx/2,y,y, p,cs) == 1 ) i--;
      } if( i ) break;
      if( num_hole(x0, x1, y0      , y1      ,p,cs)  > 0 ) // kommt vor!
      if( num_hole(x0, x1, y0+dy/3 , y1-dy/3 ,p,cs) != 1 ) break; // mini
      bc='h'; break;
   }
   // --- test H ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for( i=1,y=y0+dy/10; y<y1-dy/10 && i; y++ ) // 2 vertikal lines
      { j=loop(p,x0  ,y,dx,cs,0,RI);
         +loop(p,x1  ,y,dx,cs,0,LE); if( j>dx/2 ) i=0; } 
      if( !i ) break;
      for( i=1,y=y0+dy/3; y<y1-dy/3 && i; y++ ) // horizontal line
      { j=loop(p,x0  ,y,dx,cs,0,RI);
        j=loop(p,x0+j,y,dx,cs,1,RI); if( j>dx/2 ) i=0; } 
      if( i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x,y0     ,y0+dy/4,p,cs,1) == 0 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x,y1-dy/4,y1     ,p,cs,1) == 0 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( num_cross(x,x,y0+dy/8,y1-dy/8, p,cs) == 1 ) i=0;
      } if( i ) break;
      for(i=1,y=y0;y<=y0+dy/4 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y1-dy/4;y<=y1 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      if( get_bw(x1-dx/8, x1     , y0, y0+dy/8,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/8, y1-dy/8, y1,p,cs,1) != 1 ) break;
      i=loop(p,x1,y0+dy/4,x1-x0,cs,0,LE); if(i>dx/2) break;
      j=loop(p,x1,y0+dy/2,x1-x0,cs,0,LE); if(j<i-dx/4 || j>i+dx/8) break; i=j;
      j=loop(p,x1,y1-dy/4,x1-x0,cs,0,LE); if(j<i-dx/4 || j>i+dx/8) break;
      return 'H';
   }
   // --- test k ---------------------------------------------------
   for(;dx>2 && dy>3;){     // min 3x4
      if( y0>(box1->m1+box1->m2)/2 ) break;
      if( get_bw(x0     , x0+dx/4, y0     , y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x1,      y1-dy/3, y1     ,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3, x1,      y0     , y0+dy/4,p,cs,1) == 1 ) break;
      if( get_bw(x1-1   , x1,      y1-1   , y1     ,p,cs,1) != 1 ) break;
      if( num_hole(x0     , x1     , y0+dy/4, y1   ,p,cs  ) != 0 ) break;
      for(y=y0+1;y<y0+dy/2;y++)		// luecke ???
        if( get_bw(x0,x1,y,y,p,cs,1) == 0 ) break;
      if( y<y0+dy/2 ) break;
      int i;
      for(i=1,x=x0;x<=x0+dx/2 && i;x++) 
        if(get_line(x,y0     ,x ,y1,p,cs,100)>50) i=0;
      if( i ) break;				// no vertikal line!
      for(i=1,y=y0+dy/3;y<=y1-dy/3 && i;y++) 
        if(get_line(x0+dx/4,y,x1,y1,p,cs,100)>60) i=0;
      if( i ) break;				// no falling line!
      for(i=1,y=y0+dy/2;y<=y1-dy/4 && i;y++) 
        if(get_line(x1-dx/3,y,x1,y ,p,cs,100)<13) i=0;
      if( i ) break;				// no white range
      for(y=y0+dy/3;y<y1;y++) if( num_cross(x0,x1,y,y,p,cs)==2 ) break;
      if( y==y1 ) break;
      bc='k'; break;
   }
   // --- test K ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for(i=1,y=y0+dy/8;y<=y1-dy/8 && i;y++){
        if( get_bw(x0     , x0+dx/2,y, y,p,cs,1) != 1 ) i=0;
      } if( !i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x, y0,    y0+dy/4,p,cs,3) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x,y1-dy/4,y1     ,p,cs,3) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/3;x<=x1-dx/8 && i;x++){
        if( num_cross(x,x,y0,y1, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y0;y<=y0+dy/4 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      if( dx<10 ){
        for(i=1,y=y0+dy/3;y<=y1-dy/3 && i;y++){
          if( num_cross(x0,x1,y,y, p,cs) == 1 ) i=0;
        } if( i ) break;
      }
      for(i=1,y=y1-dy/4;y<=y1 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      if( get_bw(x1-dx/3, x1     , y0, y0+dy/4,p,cs,1) != 1 ) break;
      i=loop(p,x1,y0+dy/4,x1-x0+1,cs,0,LE); if(i>dx/2) break;
      j=loop(p,x1,y0+dy/2,x1-x0+1,cs,0,LE); if(j<=i  ) break; i=j;
      j=loop(p,x1,y1-dy/4,x1-x0+1,cs,0,LE); if(j>=i  ) break;
      bc='K'; break;
   }
   // --- test beta,\3,sz ---------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      int i;
      for(i=1+dy/20,y=y0+dy/5;y<y1-dy/4 && i;y++){
        if( num_cross(x0 ,x1 ,y,y,p,cs) != 2 ) i--;
        if( get_bw(x0,x0+dx/4,y,y,p,cs,1) == 0 ) i--;
        if( get_bw(x1-dx/2,x1,y,y,p,cs,1) == 0 ) i--;
      } if( !i ) break;
      for(y=y0+dy/3;y<y1-dy/3;y++)
        if( get_bw(x1-dx/6-1,x1,y,y,p,cs,1) == 0 ) break;
      if( y>=y1-dy/3 ) break;
      for(y=y0+dy/5;y<y0+dy/3;y++)
        if( get_bw(x1-dx/6,x1,y,y,p,cs,1) == 1 ) break;
      if( y>=y0+dy/3 ) break;
      for(y=y0+dy/2;y<y1;y++)
        if( get_bw(x1-dx/6,x1,y,y,p,cs,1) == 1 ) break;
      if( y>=y1 ) break;
      for(x=x0+dx/4;x<x1-dx/4;x++)
        if( num_cross(x,x,y0,y1,p,cs) == 3 ) break;
      if( x>=x1-dx/4 ) break;
      for(i=dx/19+1,x=x0+dx/5;x<x1-dx/3 && i;x++)
        if( get_bw(x,x,y1-dy/3,y1,p,cs,1) == 0 ) i--;
      if( i ) break;
      for(x=x0+dx/5;x<x1-dx/3;x++)
        if( get_bw(x,x,y0,y0+dy/4,p,cs,1) == 0 ) break;
      if( x<x1-dx/3 ) break;
      if( num_hole( x0, x1, y0, y1,p,cs) != 0 ) break;
      bc=223; break;
   }
   // --- test B ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i;
      for(i=1,y=y0;y<y1-dy/2 && i;y++)
      if( get_bw(x0,x0+dx/2, y      , y      ,p,cs,1) != 1 ) i=0;
      if( !i ) break;
      for(i=1,y=y1-dy/2;y<y1 && i;y++)
      if( get_bw(x0,x0+dx/3, y      , y      ,p,cs,1) != 1 ) i=0;
      if( !i ) break;
      if( get_bw(x1,x1     , y0     , y0     ,p,cs,3) != 2 ) break;
      if( num_hole(x0 , x1   , y0+dy/3, y1     ,p,cs) != 1 ) break;
      if( num_hole(x0 , x1   , y0     , y1-dy/3,p,cs) != 1 ) break;
      if( num_cross(x0+dx/2, x0+dx/2,y0,y1    ,p,cs) != 3 )
      if( num_cross(x1-dx/3, x1-dx/3,y0,y1    ,p,cs) != 3 ) break;
      for( x=dx,y=y0+dy/6; y<y1-dy/9; y++ ) // left border straight
      { i=loop(p,x0,y,dx,cs,0,RI); if( i>x+dx/9 ) break;
        if(i<x) x=i;
      } if( y<y1-dy/9 ) break;	// 8
      bc='B'; break;
   }
   // --- test b ---------------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      for(y=y0;y<y1;y++)
      if( get_bw(x0       , x0+dx/2, y      , y      ,p,cs,1) != 1 ) break;
      if(y<y1) break;
      if( get_bw(x0+  dx/2, x0+dx/2, y1-dy/3, y1     ,p,cs,1) != 1 ) break;
      if( get_bw(x1-  dx/2, x1     , y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x1-  dx/3, x1     , y0     , y0+dy/5,p,cs,1) == 1 ) break;
      if( get_bw(x1-4*dx/9, x1     , y0+dy/5, y0+dy/5,p,cs,1) == 1 ) break;
      if( num_cross(x0,x1,y0+dy/4  ,y0+dy/4  ,p,cs) > 1 ) // &
      if( num_cross(x0,x1,y0+dy/4-1,y0+dy/4-1,p,cs) > 1 ) break;
      if( num_hole( x0, x1 , y0+dy/4, y1,p,cs) != 1 ) break;
      return 'b';
   }
   // --- test D ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      if(dots) break;
      if( get_bw(x0     ,x0+dx/3,y0+dy/2,y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3,x1     ,y0+dy/2,y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3,x1     ,y0+dy/2,y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x1     ,x1     ,y0     ,y0     ,p,cs,3) != 2 ) break;
      if( get_bw(x1-dx/2,x1     ,y0     ,y0+dy/4,p,cs,1) != 1 ) break;
      if( num_cross(x0+dx/2,x0+dx/2,y0     ,y1     ,p,cs) != 2 )
      if( num_cross(x1-dx/3,x1-dx/3,y0     ,y1     ,p,cs) != 2 ) break;
      if( num_cross(x0     ,x1     ,y0+dy/3,y0+dy/3,p,cs) != 2 ) break;
      if( num_cross(x0     ,x1     ,y1-dy/3,y1-dy/3,p,cs) != 2 ) break;
      if( num_hole  (x0     ,x1     ,y0     ,y1     ,p,cs) != 1 ) break;
      // test ob linke Kante gerade
      for(x=0,y=b.y-1-dy/8;y>=dy/5;y--){ // rechts abfallende Kante/Knick?
        i=loop(b,0,y,x1-x0,cs,0,RI);
        if( i+2<=x ) break;
        if( i>x ) x=i;
      }
      if (y>=dy/5 ) break; 
      // test ob rechte Kante abfallend
      for(x=dx,y=0;y<dy/3;y++){ // rechts abfallende Kante/Knick?
        i=loop(b,b.x-1,y,x1-x0,cs,0,LE);
        if( i>x ) break;
        if( i<x ) x=i;
      }
      if (y<dy/3 ) break; 
      // test ob rechte Kante ansteigend
      for(x=dx,y=b.y-1;y>2*dy/3;y--){ // rechts abfallende Kante/Knick?
        i=loop(b,b.x-1,y,x1-x0,cs,0,LE);
        if( i>x ) break;
        if( i<x ) x=i;
      }
      if (y>2*dy/3 ) break; 
      if( loop(b,dx-1,dy-1  ,dx,cs,0,LE) <=
          loop(b,dx-1,dy-1-1,dx,cs,0,LE)   ) break;  // P

      bc='D'; break;
   }
   // --- test d ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      if( get_bw(x0     , x0+dx/2, y1-dy/6, y1-dy/9,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/2, y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x1     , y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2, y1-dy/4, y1     ,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/3, y0     , y0+dy/5,p,cs,3) != 2 ) break;
      if( loop(b,b.x-1,  b.y/4,x1-x0,cs,0,LE) >
          loop(b,b.x-1,3*b.y/4,x1-x0,cs,0,LE)+1 ) break;
      for(i=dx/8+1,x=0;x<dx && i;x++){
        if( num_cross(x ,x   ,0  ,dy-1, b,cs) == 2 ) i--;
      } if( i ) break;
      for(i=dy/6+1,y=dy/4;y<dy && i;y++){
        if( num_cross(0 ,dx-1,y  ,y   , b,cs) == 2 ) i--;
      } if( i ) break;
      for(i=dy/8+1,y=0;y<dy/2 && i;y++){
        if( num_cross(0   ,dx-1,y ,y  , b,cs) == 1 )
        if( num_cross(dx/2,dx-1,y ,y  , b,cs) == 1 ) i--;
      } if( i ) break;
      if( num_hole(x0 , x1 , y0+dy/4 , y1 ,p,cs) !=1 ) break;
      bc='d'; break;
   }
   // --- test F ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // dx>1 dy>2*dx 
      int i,j;

      for( i=1,y=y0; y<y0+dy/4 && i; y++ ){ // long black line
        j=loop(p,x0  ,y,dx,cs,0,RI);
        j=loop(p,x0+j,y,dx,cs,1,RI); if( j>dx/2 ) i=0; } 
      if( i ) break;
      x=loop(p,x0  ,y1-dy/4,dx,cs,0,RI);
      x=loop(p,x0+x,y1-dy/4,dx,cs,1,RI); // strichdicke
      for( i=1,y=y0+dy/3; y<y1-dy/3 && i; y++ ) // black line
      { j=loop(p,x0  ,y,dx,cs,0,RI);
        j=loop(p,x0+j,y,dx,cs,1,RI); if( j>dx/3 && j>2*x) i=0; } 
      if( i ) break;
      for( i=1,y=y0+dy/8; y<y1-dy/2 && i; y++ ) // white line
        if( get_bw(x1-dx/3,x1-dx/5,y,y,p,cs,1) == 0 ) i=0;
      if( i ) break;

      for(i=1,y=y0;y<=y0+dy/2 && i;y++)
      if( get_bw(x0,x0+dx/2,y,y,p,cs,1) != 1 ) i=0;
      if( !i ) break;
      for(i=1,y=y0+dy/2;y<=y1 && i;y++)
      if( get_bw(x0,x0+dx/3,y,y,p,cs,1) != 1 ) i=0;
      if( !i ) break;
      if( get_bw(x1-dx/3,x1,y1     ,y1     ,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/4,x1,y1-dy/4,y1     ,p,cs,1) == 1 ) break;
      if( get_bw(x1     ,x1,y0     ,y0+dy/3,p,cs,1) != 1 ) break;
      if( loop(b,0,  b.y/4,dx,cs,0,RI) <
          loop(b,0,3*b.y/4,dx,cs,0,RI)-1 ) break;
      if( num_hole(x0 , x1 , y0 , y1 ,p,cs) >0 ) break;
      bc='F';break;
   }
   // --- test L ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i,j;
      for( i=1,y=y1-dy/5;y<=y1 && i;y++){ 	// querstrich
        j=loop(p,x0  ,y,dx,cs,0,RI);
        j=loop(p,x0+j,y,dx,cs,1,RI); if( j>3*dx/4 ) i=0;
      } if( i ) break;
      i=loop(p,x0  ,y0+dy/2,dx,cs,0,RI); if( i>dx/2   ) break; // strichdicke
      i=loop(p,x0+i,y0+dy/2,dx,cs,1,RI); if( i>dx/4+2 ) break;
      for( y=y0+dy/8;y<=y1-dy/4 && i;y++){ 	// laengsstrich
        j=loop(p,x0  ,y,dx,cs,0,RI); if( j>dx/2 ) i=0;
        x=loop(p,x0+j,y,dx,cs,1,RI); if( x>i+1  ) i=0;
      } if( !i ) break;
      if( num_cross(x0, x1-dx/8, y1-dy/3, y1-dy/3,p,cs) != 1 ) break;
      if( num_cross(x0, x1     , y0+dy/3, y0+dy/3,p,cs) != 1 ) break;
      x=0;y=dy-1-dy/4;
      turmite(b,x,y,0,dx-1,0,dy-1,cs,RI,ST); if( x>dx/4 ) break;
      turmite(b,x,y,0,dx-1,0,dy-1,cs,ST,RI); if( x>dx/2 ) break;
      bc='L'; break;
   }
   // --- test l ---------------------------------------------------
   for(d=100; dy>dx && dy>6;){     // min 3x4
      if( dots==1 ) break;
      int i,j,i1,i2;
	// mesure thickness
      if( box1->m2-box1->m1 > 1 
      &&  y0>=box1->m2 ) break;
      for(i1=0,i2=dx,i=1,y=dy/8;y<dy-dy/8 && i;y++){
        j = loop(b,0,y,dx,cs,0,RI);
        j = loop(b,j,y,dx,cs,1,RI);
        if( j>i1 ) { i1=j; } // thickest
        if( j<i2 ) { i2=j; } // thinnest
      }
      if ( i1>2*i2 ) break;

      if( get_bw(x0,x1,y0,y1,p,cs,2) == 0 ) break; // unsure !I|

      if(dx>3)
      if( get_bw(dx-1,dx-1,0,dy/6,b,cs,3) == 2 )
      if( get_bw(dx-1,dx-1,0,dy/2,b,cs,1) == 1 ) break;

      if( get_bw(dx-1,dx-1,dy/4,dy/3,b,cs,3) == 2 ) // large I ???
      if( get_bw(0   ,0   ,dy/4,dy/3,b,cs,3) == 2 )
      if( get_bw(dx-1,dx-1,0   ,0   ,b,cs,1) == 1 )
      if( get_bw(0   ,0   ,0   ,0   ,b,cs,1) == 1 ) break;
      if( get_bw(dx-1,dx-1,dy/2,dy-1,b,cs,3) == 2 ) // r ???
      if( get_bw(0   ,0   ,dy/2,dy-1,b,cs,1) == 1 )
      if( get_bw(dx-1,dx-1,0   ,dy/3,b,cs,1) == 1 )
      if( get_bw(0   ,0   ,0   ,dy/3,b,cs,1) == 1 ) break;

      for( y=0;y<dy-1-dy/5;y++ )
      if( num_cross(0, dx-1, y  , y  ,b,cs) != 1 )	// sure ?
      if( num_cross(0, dx-1, y+1, y+1,b,cs) != 1 ) break;
      if( y<dy-1-dy/5 ) break;

      if(dx>3){
        for( y=dy/2;y<b.y;y++ )
        if( get_bw(dx/4,dx-1-dx/3,y,y,b,cs,1) != 1 ) break;
        if( y<b.y ) break;
      }
      // test ob rechte Kante gerade
      for(x=dx,y=b.y-1-dy/5;y>=dy/5;y--){ // rechts abfallende Kante/Knick?
        i=loop(b,b.x-1,y,x1-x0,cs,0,LE);
        if( i-2>=x ) break;
        if( i<x ) x=i;
      }
      if (y>=dy/5 ) break; 

      // test ob linke Kante gerade
      for(x=0,y=b.y-1-dy/5;y>=dy/5;y--){ // rechts abfallende Kante/Knick?
        i=loop(b,0,y,x1-x0,cs,0,RI);
        if( i+2<=x ) break;
        if( i>x ) x=i;
      }
      if (y>=dy/5 ) break; 

      if( get_bw(x0,x1,y1+1,y1+dy/3,p,cs,1) == 1 ) break; // unsure !l|

      bc='l';
      break;
   }
   // --- test o,O ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i;
      if( get_bw(x0      , x0+dx/2,y0+dy/2 , y0+dy/2,p,cs,1) != 1 ) break;
//      out_b(b,0,0,dx,dy,cs);
      if( get_bw(x1-dx/2 , x1     ,y0+dy/2 , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y1-dy/2 , y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y0      , y0+dy/2,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2 , x0+dx/2,y0+dy/3 , y1-dy/3,p,cs,3) != 2 ) break;

      if( num_cross(x0+dx/2,x0+dx/2,y0      , y1     ,p,cs)  != 2 ) break;
      if( num_cross(x0+dx/3,x1-dx/3,y0      , y0     ,p,cs)  != 1 ) // AND
      if( num_cross(x0+dx/3,x1-dx/3,y0+1    , y0+1   ,p,cs)  != 1 ) break;
      if( num_cross(x0+dx/3,x1-dx/3,y1      , y1     ,p,cs)  != 1 ) // against "rauschen"
      if( num_cross(x0+dx/3,x1-dx/3,y1-1    , y1-1   ,p,cs)  != 1 ) break;
      if( num_cross(x0     ,x0     ,y0+dy/3 , y1-dy/3,p,cs)  != 1 )
      if( num_cross(x0+1   ,x0+1   ,y0+dy/3 , y1-dy/3,p,cs)  != 1 ) break;
      if( num_cross(x1     ,x1     ,y0+dy/3 , y1-dy/3,p,cs)  != 1 )
      if( num_cross(x1-1   ,x1-1   ,y0+dy/3 , y1-dy/3,p,cs)  != 1 ) break;
      if( num_hole(x0,x1,y0,y1,p,cs) != 1 ) break;
      
      if( loop(b,0   ,0   ,x1-x0,cs,0,RI)<=
          loop(b,0   ,2   ,x1-x0,cs,0,RI)  ) break;

      x=loop(b,dx-1,dy-1-dy/3,x1-x0,cs,0,LE);	// should be minimum
      for( y=dy-1-dy/3;y<dy;y++ ){
        i=loop(b,dx-1,y,x1-x0,cs,0,LE);
        if( i<x ) break; x=i;
      }
      if( y<dy ) break;
      bc='o';      if(um=='\"') bc=246;
      if( hchar ){ if(um=='\"') bc=214; else bc='O'; }
      break;
   }
   // --- test pP ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for ( x=0,j=y=dy/3; y<7*dy/8; y++ ){ // suche unterkante
        i=loop(b,dx-1,y,dx,cs,0,LE);
        if ( i>x ) { x=i; j=y; } if(x>dx/2) break;
      } if ( x<dx/2 || x>=dx) break;
      if( get_bw(0   , dx/2,3*dy/4,3*dy/4,b,cs,1) != 1 ) break;
      if( get_bw(0   , dx/2,  dy/2,  dy/2,b,cs,1) != 1 ) break;
      if( get_bw(dx/4, dx-1,  dy/4,  dy/4,b,cs,1) != 1 ) break;
      if( get_bw(3*dx/4,dx-1, y      , dy-1,b,cs,1) == 1 ) break;
      if( num_cross(x0+dx/2  ,x0+dx/2  , y0, y1-3*dy/16,p,cs) != 2 )
      if( num_cross(x0+dx/2+1,x0+dx/2+1, y0, y1-3*dy/16,p,cs) != 2 ) break;
      if( num_hole (x0     ,x1     , y0, y1-dy/5,p,cs) != 1 ) break;
      // out_b(p,x0,y0,dx,dy,cs); printf(" xyd %d %d %d\n",x,y,dx);
      bc='p'; if( hchar && !gchar ) bc='P';
      break;
   }
   // --- test Q ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i;
      if( get_bw(x0     ,x0+dx/3,y0+dy/3,y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3,x1     ,y0+dy/3,y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2,x0+dx/2,y1-dy/3,y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2,x0+dx/2,y0     ,y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2,x0+dx/2,y0+dy/3,y1-dy/2,p,cs,1) == 1 ) break;
      if( get_bw(x1     ,x1     ,y0     ,y0     ,p,cs,1) == 1 ) break; //alpha

      if( num_cross(x0+dx/2,x0+dx/2,y0      , y1     ,p,cs)  <  2 ) break;
      if( num_cross(x0+dx/5,x1-dx/5,y0      , y0     ,p,cs)  != 1 ) // AND
      if( num_cross(x0+dx/5,x1-dx/5,y0+1    , y0+1   ,p,cs)  != 1 ) break;

      if( num_cross(x0     ,x0     ,y0+dy/3 , y1-dy/3,p,cs)  != 1 )
      if( num_cross(x0+1   ,x0+1   ,y0+dy/3 , y1-dy/3,p,cs)  != 1 ) break;
      if( num_cross(x1     ,x1     ,y0+dy/3 , y1-dy/3,p,cs)  != 1 )
      if( num_cross(x1-1   ,x1-1   ,y0+dy/3 , y1-dy/3,p,cs)  != 1 ) break;

      i=num_hole(x0,x1,y0,y1,p,cs);
      if(!i) break;
      if( i!=1 && (i!=2 || num_hole(x0,x1,y0+dy/2,y1,p,cs)!=1) ) break;
      
      x=x1;y=y1;
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST); if( x<x1-dx/4 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,LE); if( x<x1-dx/2 ) break;
//      out_b(b,0,0,dx,dy,cs);
      if( loop(b,0   ,0   ,dx,cs,0,RI)<=
          loop(b,0   ,2   ,dx,cs,0,RI)       ) break;
      if( loop(b,dx-1,0   ,dy,cs,0,DO)<=
          loop(b,dx-2,0   ,dy,cs,0,DO)       ) break;	// 4
      if( loop(b,dx-1,dy/3,dx,cs,0,LE)> dx/4 ) break;
      return 'Q';
   }
   // --- test q ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for ( x=0,y=y0+dy/3; y<y1-dy/5; y++ ){ // suche unterkante
        i=loop(p,x0,y,dx,cs,0,RI);
        if ( i>x ) { x=i; j=y; }
      } if ( x<dx/2 || x>=dx) break;
      if( loop(p,x0,j,dy,cs,0,UP)<2 ) break; // 4 
      if( get_bw(x1-dx/3, x1     , y0+dy/3, y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/3, y0+dy/3, y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/4, y1-dy/5, y1-dy/9,p,cs,1) == 1 ) break;
      if( num_cross(x0+dx/2,x0+dx/2, y0, j      ,p,cs) != 2 ) break;
      if( num_hole (x0     ,x1     , y0, y1     ,p,cs) != 1 ) break;
      if( num_hole (x0     ,x1     , y0, j      ,p,cs) != 1 ) break;
      bc='q';
      break;
   }
   // --- test ij ---------------------------------------------------
   if(dots==1)
   for(d=100;dy>4 && dx>1;){     // min 3x4
      if( dots!=1 || y0>box1->m2+2 ) break;

      if( num_cross(0,dx-1,  dy/2,  dy/2,b,cs) != 1 
       && num_cross(0,dx-1,3*dy/4,3*dy/4,b,cs) != 1  )
      break; // ???

      // out_b(p,x0,y0,dx,dy,cs); printf(" ok? %d\n",dots);

      if( gchar ) return 'j';
      return 'i';
   }
   // --- test I ---------------------------------------------------
   if(/*hchar &&*/ !gchar) // serif  Mar2000
   for(d=100;dy>4 && dy>dx && 5*dy>4*(box1->m3-box1->m2);){     // min 3x4
      int i,j,i1,i2,i3;
      if( dots==1 ) break;

      for( i=dy/20+1,y=1;y<dy-1 && i;y++ )	// 5% Fehlertoleranz
      if( num_cross(0, dx-1, y  , y  ,b,cs) != 1 ) i--;
      if( !i ) break;

      // calculate upper and lower mass center
      x =loop(b,0,  dy/8,dx,cs,0,RI); i1=x;
      x+=loop(b,x,  dy/8,dx,cs,1,RI); i1=(i1+x-1)/2;

      x =loop(b,0,7*dy/8,dx,cs,0,RI); i2=x;
      x+=loop(b,x,7*dy/8,dx,cs,1,RI); i2=(i2+x-1)/2;
      x =(i1-i2+4)/8; i1+=x; i2-=x;

      if( get_line2(i1,0,i2,dy-1,b,cs,100)<95 ) break;

      // upper and lower width
      x =loop(b,i1,   0,dx,cs,1,LE); i=x; i3=0;
      x =loop(b,i1,   1,dx,cs,1,LE); if(x>i)i=x;
      x =loop(b,i1,   0,dx,cs,1,RI); j=x;
      x =loop(b,i1,   1,dx,cs,1,RI); if(x>j)j=x; if(abs(i-j)>1+dx/16)i3|=1;
      x =loop(b,i2,dy-1,dx,cs,1,LE); j=x;
      x =loop(b,i2,dy-2,dx,cs,1,LE); if(x>j)j=x; if(abs(i-j)>1+dx/16)i3|=1;
      x =loop(b,i2,dy-1,dx,cs,1,RI); j=x;
      x =loop(b,i2,dy-2,dx,cs,1,RI); if(x>j)j=x; if(abs(i-j)>1+dx/16)i3|=1;
      if(i3) break;

      // out_b(b,0,0,dx,dy,cs); printf(" i12 %d %d %d\n",i1,i2,i3);
      return 'I';
   }
   // --- test J ---------------------------------------------------
   for(d=100;dy>4 && dy>=dx && dx>2;){     // min 3x4
      int i;
      if( loop(b,0   ,  dy/2,dx,cs,0,RI)
        <=loop(b,dx-1,  dy/2,dx,cs,0,LE)+dx/6 ) break;
      if( loop(b,0   ,  dy/6,dx,cs,0,RI)
        <=loop(b,dx-1,  dy/6,dx,cs,0,LE)+dx/6 ) break;
      if( loop(b,0   ,2*dy/3,dx,cs,0,RI)
        <=loop(b,dx-1,2*dy/3,dx,cs,0,LE)      ) break;
      // test ob rechte Kante gerade
      for(x=0,y=0;y<dy;y++){ // rechts abfallende Kante/Knick?
        i=loop(b,dx-1,y,dx,cs,0,LE);
        if( i+1<x ) break;
        if( i>x ) x=i;
      } if (y<dy ) break; 

      if( get_bw(x0     ,x0+dx/3,y0+dy/8,y1-dy/3,p,cs,1) == 1 ) break;
      if( get_bw(dx-1   ,dx-1   ,dy-1   ,dy-1   ,b,cs,1) == 1 ) break;
      if( get_bw(x0     ,x0+dx/2,y1-dy/5,y1     ,p,cs,1) != 1 ) break;
      if( dots==1 ) return 'j';
      if( dots!=0 ) break;
      return 'J';
   }
   // --- test T ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // dx>1 dy>2*dx 
      int i;
      for( i=1,y=y0;y<y0+dy/6 && i;y++)		// oberer Balken?
      if( get_bw(x0+dx/4,x1-dx/8,y,y,p,cs,2) == 0 ) i=0;
      if( i ) break;
      if( get_bw(        0,dx/3,        0,     dy/8,b,cs,1) != 1 ) break;
      if( get_bw(        0,dx/8,     dy/2,dy-1-dy/8,b,cs,1) == 1 ) break;
      if( get_bw(        0,dx/4,     dy/2,dy-1-dy/4,b,cs,1) == 1 ) break;
      if( get_bw(dx-1-dx/4,dx-1,     dy/2,dy-1-dy/4,b,cs,1) == 1 ) break;
      // top max width x
      for( x=0,y=0;y<dy/4;y++){		// oberer Balken?
        i=loop(b,0,y,dx,cs,0,RI);
        i=loop(b,i,y,dx,cs,1,RI);if(i>x) x=i; // max. width
      } if( x<=dx/2 ) break;
      // center width
      for( y=dy/4;y<3*dy/4;y++){		// oberer Balken?
        i=dx/4+loop(b,dx/4,y,dx,cs,0,RI);if(i==dx/4) break; // ~r
        i=     loop(b,   i,y,dx,cs,1,RI);if(2*i>x) break;
      } if( y<3*dy/4 ) break;
      // down width
      for( y=3*dy/4;y<dy;y++){
        i=     loop(b,dx/4,y,dx,cs,0,RI);
        i=     loop(b,   i,y,dx,cs,1,RI);if(4*i>3*x) break; //~I
      } if( y<dy ) break;

      i =dx/2+loop(b,dx/2,dy/4,dx,cs,0,RI);if(i>3*dx/4) break; // ~7
      i+=     loop(b,i   ,dy/4,dx,cs,1,RI);if(i>3*dx/4) break;

      if( num_cross(0,dx-1,  dy-1,  dy-1,b,cs) != 1
       && num_cross(0,dx-1,  dy-2,  dy-2,b,cs) != 1 ) break;
      if( num_cross(0,dx-1,2*dy/3,2*dy/3,b,cs) != 1
       && num_cross(0,dx-1,2*dy/3,2*dy/3,b,cs) != 1 ) break;
//      out_b(p,x0,y0,dx,dy,cs);
      return 'T';
   }
   // --- test t ---------------------------------------------------
   if((!gchar) && (!dots))
   for(d=100;dx>2 && dy>box1->m3-box1->m2+1;){     // sometimes no hchar! 
      int i,j;
      for(x=0,j=y=1+3*dy/16;y<4*dy/8;y++){ // upper cross line
        i=loop(b,0,y,dx,cs,0,RI); if( y>dy/4 && i>dx/2 ) break;
        i=loop(b,i,y,dx,cs,1,RI); if( i>x ) { x=i;j=y; }
        if( y<3*dy/4
         && num_cross(0,dx-1,y  ,y  ,b,cs) != 1
         && num_cross(0,dx-1,y+1,y+1,b,cs) != 1  // against noise
          ) break;
      } if( y<4*dy/8 ) break; y=j;// if( y>dy/2 || y<dy/8 ) break;
       
      i=loop(b,0,dy/2,dx,cs,0,RI);
      i=loop(b,i,dy/2,dx,cs,1,RI); // thickness
      if( 2*x<3*i ) break;

      if( loop(b,dx-1,dy/2,dx,cs,0,LE)-1
        <=loop(b,dx-1, y  ,dx,cs,0,LE) ) break; // ~1

      i=y;j=1;
      for(y=1;j && y<i;   y++)  // no @@ pattern
      for(x=0;j && x<dx-2;x++){ //    ..
        if(  pixel(b,x  ,y  )>=cs && pixel(b,x+1,y  )>=cs
          && pixel(b,x  ,y-1)< cs && pixel(b,x+1,y-1)< cs ) { j=0;break; }
      } if(!j) break;

      // out_b(p,x0,y0,dx,dy,cs); printf(" out_t xyi %d %d %d %d\n",x,y,i,j);

      return 't';
   }
   // --- test sS near 5 ---------------------------------------------------
   if(!gchar)
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i1,i2,i3;
      if( num_cross(  dx/2,  dx/2,0,dy-1,b,cs)!=3
      &&  num_cross(5*dx/8,3*dx/8,0,dy-1,b,cs)!=3 ) break;
      // get the upper and lower hole koords
      y=dy/4;
      x  =loop(b,0,y,dx,cs,0,RI); if(x>dx/4) break;
      x +=loop(b,x,y,dx,cs,1,RI); if(x>dx/2) break;
      i1 =loop(b,x,y,dx,cs,0,RI); i1=(i1+2*x)/2; // upper center x
      y=11*dy/16;
      x  =loop(b,dx-1  ,y,dx,cs,0,LE); if(x>dx/4) break;
      x +=loop(b,dx-1-x,y,dx,cs,1,LE); if(x>dx/2) break;
      i2 =loop(b,dx-1-x,y,dx,cs,0,LE); i2=dx-1-(i2+2*x)/2; // upper center x

      y=dy/2-loop(b,dx-1,dy/2,dy/2,cs,1,UP);
      if( !joined(b,i1,dy/4,dx-1,y,cs) ) break;

      y=dy/2+loop(b,0,dy/2,dy/2,cs,1,DO);
      if( !joined(b,0,y,i2,11*dy/16,cs) ) break;

      if( num_hole( x0, x1, y0, y1, p,cs) > 0 ) break;

      // sS5 \sl z  left upper v-bow ?

      i1=loop(b,0,  dy/16,dx,cs,0,RI);
      i2=loop(b,0,4*dy/16,dx,cs,0,RI);
      i3=loop(b,0,7*dy/16,dx,cs,0,RI);
      if( 2*i2+dx/16 >= i1+i3 ) break;
      // out_b(b,0,0,dx,dy,cs);

      bc='s'; if( hchar ) bc='S';
      return bc;
   }
   // --- test 5 near S ---------------------------------------------------
   if(hchar && (!gchar))
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i1,i2,i3;
      if( num_cross(  dx/2,  dx/2,0,dy-1,b,cs)!=3
      &&  num_cross(5*dx/8,3*dx/8,0,dy-1,b,cs)!=3 ) break;
      // get the upper and lower hole koords
      y=dy/4;
      x  =loop(b,0,y,dx,cs,0,RI); if(x>dx/4) break;
      x +=loop(b,x,y,dx,cs,1,RI); if(x>dx/2) break;
      i1 =loop(b,x,y,dx,cs,0,RI); i1=(i1+2*x)/2; // upper center x
      y=11*dy/16;
      x  =loop(b,dx-1  ,y,dx,cs,0,LE); if(x>dx/4) break;
      x +=loop(b,dx-1-x,y,dx,cs,1,LE); if(x>dx/2) break;
      i2 =loop(b,dx-1-x,y,dx,cs,0,LE); i2=dx-1-(i2+2*x)/2; // upper center x

      for(y=dy/4;y<3*dy/4;y++) // right gap?
      if( num_cross(i1,dx-1,dy/4,y,b,cs)==0 ) break;
      if( y==3*dy/4 ) break;

      for(y=dy/4;y<11*dy/16;y++) // left gap?
      if( num_cross(0,i2,y,11*dy/16,b,cs)==0 ) break;
      if( y==11*dy/16 ) break;

      if( num_hole( x0, x1, y0, y1, p,cs) > 0 ) break;

      // sS5 \sl z  left upper v-bow ?

      i1=loop(b,0,  dy/16,dx,cs,0,RI);
      i2=loop(b,0,4*dy/16,dx,cs,0,RI);
      i3=loop(b,0,7*dy/16,dx,cs,0,RI);
      if( 2*i2+dx/16 < i1+i3 ) break;

      return '5';
   }
   // --- test g ---------------------------------------------------
   if(gchar && !hchar)
   for(d=100;dx>2 && dy>4;){     // min 3x4
      if( get_bw(x0+dx/2, x0+dx/2, y1-dy/2, y1,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/4, x1     , y1-dy/4, y1,p,cs,1) != 1 ) break; // ~p
      if( get_bw(x0+dx/2, x0+dx/2, y0, y0+dy/2,p,cs,1) != 1 ) break;

      if( num_cross(x0+dx/2, x0+dx/2, y0, y1, p,cs) < 3 )
      if( num_cross(x1-dx/2, x1-dx/2, y0, y1, p,cs) < 3 ) break;
      if( num_hole ( x0, x1, y0, y0+5*dy/8, p,cs) != 1 ) break;
      bc='g';
      break;
   }
   // --- test rundes G ---------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      int i;
      x=x0; y=y1;
      turmite(p,x,y,x0,x1,y0,y1,cs,UP,ST);	// left bow?
      if( y<y0+dy/2 ) break;	// filter W
      x=x1; y=y1-dy/3;		// upper right offen bow
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST);
      if( x<x1-dx/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,LE);
      if( x<x0+dx/2 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,UP);	// upper end right midle
      if( x<=x1     ) break;
      if( y<y0+dy/3 ) break;
      if( y>y1-dy/4 ) break;
      x=x1-dx/3;y=y1;				// follow C-bow
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,UP);	// filter S
      if( x>=x0 ) break; x++;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,UP);	// filter S
      if( y>=y0 ) break;      

      if( get_bw(x0     ,x0+dx/2,y0+dy/3,y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2,x1-dx/4,y0     ,y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2,x0+dx/2,y1-dy/4,y1     ,p,cs,1) != 1 ) break;
      for( i=1,y=y0+dy/4;y<y1-dy/3 && i;y++ )
      if( get_bw(x1-dx/2,x1,y,y,p,cs,1) == 0 ) i=0;
      if( i ) break;

      if( num_hole(x0,x1,y0,y1,p,cs) > 0 ) break;
      if( dx>4 && dy>6){		// no (<{[
        for(i=1,y=0;i && y<dy/3;y++)
        if( num_cross(0,dx-1,y,y,b,cs) == 2 ) i=0;
        if( i ) break;
      }
      for(i=1,y=dy/2;i && y<dy;y++)
      if( num_cross(0,dx-1,y,y,b,cs) == 2 ) i=0;
      if( i ) break;
      for(i=0,y=dy/2;y<dy;y++){
        x=loop(b,0,y,dx,cs,0,RI);	// Kante abfallend <=> Z
        if( x<i-dx/20 ) break;
        if( x>i ) i=x;
      } if( y<dy ) break;

      bc='G'; break;
   }
   // --- test xX ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for(i=1,y=y0+dy/8;y<=y1-dy/8 && i;y++){
        if( get_bw(x0     , x1-dx/4,y, y,p,cs,1) != 1 ) i=0;
      } if( !i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x, y0,    y0+dy/4,p,cs,3) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x0+dx/4;x<=x1-dx/4 && i;x++){
        if( get_bw( x, x,y1-dy/4,y1     ,p,cs,3) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x0;x<=x0+dx/3 && i;x++){
        if( num_cross(x,x,y0,y1, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,x=x1-dx/3;x<=x1 && i;x++){
        if( num_cross(x,x,y0,y1, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y0;y<=y0+dy/3 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      for(i=1,y=y0+dy/3;y<=y1-dy/3 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 1 ) i=0;
      } if( i ) break;
      for(i=1,y=y1-dy/3;y<=y1 && i;y++){
        if( num_cross(x0,x1,y,y, p,cs) == 2 ) i=0;
      } if( i ) break;
      if( get_bw(x1-dx/4, x1     , y0, y0+dy/6,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/4, y1-dy/6, y1,p,cs,1) != 1 ) break;
      i=loop(p,x1,y0+dy/6,x1-x0+1,cs,0,LE); if(i>dx/2) break;
      j=loop(p,x1,y1-dy/2,x1-x0+1,cs,0,LE); if(j<=i  ) break; i=j;
      j=loop(p,x1,y1-dy/6,x1-x0+1,cs,0,LE); if(j>=i  ) break;
      i=loop(p,x0,y0+dy/6,x1-x0+1,cs,0,RI); if(i>dx/2) break;
      j=loop(p,x0,y0+dy/2,x1-x0+1,cs,0,RI); if(j<=i  ) break; i=j;
      j=loop(p,x0,y1-dy/6,x1-x0+1,cs,0,RI); if(j>=i  ) break;
      bc='x'; if(hchar) bc='X';
      break;
   }
   // --- test yY ---------------------------------------------------
   for(d=100;dx>2 && dy>3;){     // min 3x4
      int i,j;
      for(i=1,y=dy/8;y<dy-dy/8 && i;y++){
        if( get_bw( 0,dx-1-dx/3,y, y,b,cs,1) != 1 ) i=0;
      } if( !i ) break;
      for(y=0,x=dx/4;x<dx-dx/4;x++){  // search deepest point
        i=loop(b,x,0,dy,cs,0,DO); if(i>y) y=i;
      } if( y>10*dy/16 || y<2*dy/8 ) break;
      if( get_bw( dx-1-dx/4,dx-1,dy-1-dy/4,dy-1 ,b,cs,1) == 1 ) break;
      for(i=1,x=dx-1-dx/3;x<dx && i;x++){
        if( num_cross(x,x,0,dy-1,b,cs) == 1 ) i=0;
      } if( i ) break;
      if( num_cross(0,dx-1,     dy/4,     dy/4, b,cs) != 2 ) break;
      if( num_cross(0,dx-1,dy-1-dy/4,dy-1-dy/4, b,cs) != 1 ) break;
      if( get_bw(dx-1-dx/4, dx-1,  0, dy/6,b,cs,1) != 1 ) break;
      if( get_bw( 0, dx/2, dy-1-dy/6, dy-1,b,cs,1) != 1 ) break;

      i=loop(b,dx-1,     dy/8,dx,cs,0,LE); if(i>dx/2) break;
      j=loop(b,dx-1,dy-1-dy/2,dx,cs,0,LE); if(j<=i  ) break; i=j;
      j=loop(b,dx-1,dy-1-dy/8,dx,cs,0,LE); if(j<dx/3) break;

      i=loop(b,0,     dy/8,dx,cs,0,RI); if(i>dx/3) break;
      j=loop(b,0,     dy/2,dx,cs,0,RI); if(j<=i  ) break; i=j;
      j=loop(b,0,dy-1-dy/8,dx,cs,0,RI); if(j>dx/2) break;

      if(gchar && !hchar) bc='y'; 
      if(hchar && !gchar) bc='Y';
      break;
   }
   // --- test z -------
   if(0)
   for(d=100;dx>3 && dy>3;){     // dy>dx
      int i;
      if( get_bw(x0+dx/8, x0+dx/8,y0+dy/2, y0+dy/2,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/8, x1-dx/8,y1-dy/2, y1-dy/2,p,cs,1) == 1 ) break;
      if( get_bw(x0     , x0+dx/5,y0+dy/2, y0+dy/2,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/5, x1     ,y0+dy/2, y0+dy/2,p,cs,1) == 1 ) break;
      if( get_bw(x0     , x0+dx/4,y0     , y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/4, x1     ,y0     , y0+dy/4,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/4,y1-dy/4, y1,     p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/4, x1     ,y1-dy/4, y1,     p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/3, x1-dx/3,y0+dy/2, y0+dy/2,p,cs,1) != 1 ) break;
      for( i=1,x=0;x<=dx/2 && i;x++ ){
        if( get_bw(x0+dx/3+x,x0+dx/3+x,y0     ,y0+dy/5,p,cs,1) == 0 ) i=0;
        if( get_bw(x0+dx/8+x,x0+dx/8+x,y1-dy/5,y1     ,p,cs,1) == 0 ) i=0;
      } if( !i ) break;

      // --- follow line from left down to right up
      x=x0,y=y1;
      turmite(p,x,y,x0,x1,y0,y1,cs,UP,ST); if( y<y1-dy/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,UP);	//
      if( x<x0+dx/2 || y>y0 ) break;		// upper right edge?
      // --- vertikal line at right end
      x=x1,y=y0+dy/5;
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST); if( x<x1-dx/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,LE); if( x<x1-dx/2 ) break;
      // --- vertikal line at left end
      x=x0,y=y1-dy/5;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,ST); if( x>x0+dx/3 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,RI); if( x>x0+dx/2 ) break;

      if( num_cross(x0+1, x0+1, y0, y1,p,cs) != 2 ) break;
      if( num_hole  (x0  , x1  , y0, y1,p,cs) != 0 ) break; 

      // test ob rechte Kante ansteigend
      for(x=dx,y=b.y-1-dy/2;y>=dy/4;y--){ // rechts abfallende Kante/Knick?
        i=loop(b,b.x-1,y,x1-x0,cs,0,LE);
        if( i-2>=x ) break;
        if( i<x ) x=i;
      }
      if (y>=dy/4 ) break; 
      bc='z';
      if( hchar ) bc='Z';
      break;
   }
   // --- test 1 ---------------------------------------------------
   if(/*hchar &&*/ !gchar) // Mar2000 modified 'I'
   for(d=100;dy>4 && dy>dx && 2*dy>box1->m3-box1->m2;){     // min 3x4
      int i,j,i1,i2,i3;
      if( dots==1 ) break;

      for( i=dy/4,y=1;y<dy-1 && i;y++ )	// 5% Fehlertoleranz
      if( num_cross(0, dx-1, y  , y  ,b,cs) != 1 ) i--;
      if( !i ) break;

      // calculate upper and lower mass center
      x =loop(b,dx-1  , dy/8,dx,cs,0,LE); i1=x;
      x+=loop(b,dx-1-x, dy/8,dx,cs,1,LE); i1=dx-1-(i1+x-1)/2;

      x =loop(b,0,7*dy/8,dx,cs,0,RI); i2=x;
      x+=loop(b,x,7*dy/8,dx,cs,1,RI); i2=(i2+x-1)/2;
      x =(i1-i2+4)/8; i1+=x; i2-=x;

      if( get_line(i1,0,i2,dy-1,b,cs,100)<95 ) break;

      // upper and lower width
      x =loop(b,(i1+i2)/2,dy/2,dx,cs,1,RI); i=x; i3=0;
      for(y=0;y<7*dy/8;y++)
        if( abs( loop(b,i1+y*(i2-i1)/dy, y,dx,cs,1,RI)-i )>1+dx/16 ) break;
      if(y<7*dy/8) break;
      x =loop(b,i2,dy-1,dx,cs,1,LE); j=x;
      x =loop(b,i2,dy-2,dx,cs,1,LE); if(x>j)j=x; i=j;
      x =loop(b,i2,dy-1,dx,cs,1,RI); j=x;
      x =loop(b,i2,dy-2,dx,cs,1,RI); if(x>j)j=x; if(abs(i-j)>1+dx/16)i3|=1;
      
      for(i=dx,j=y=0;y<dy/4;y++){
        x =loop(b,0,y,dx,cs,0,RI); if(x<i) { i=x;j=y; }
      }  if ( i1-i<5*dx/8 && i1-i>7*dx/8) break;

      if(i3) break;

      x =loop(b,0,dy/2,dx,cs,0,RI);
      j =loop(b,x,dy/2,dx,cs,1,RI); if( j>x ) break; // ~l
      x =loop(b,0,0,dx,cs,0,RI); // straight line ???
      j =loop(b,0,1,dx,cs,0,RI); if( j>=x ) break; x=j; // ~l
      j =loop(b,0,2,dx,cs,0,RI); if( j>=x ) break; x=j; // ~l
//      j =loop(b,0,   0,dx,cs,0,DO); if( !j  ) break; // ~7

      // out_b(b,0,0,dx,dy,cs); printf(" i12 %d %d %d\n",i1,i2,i3);
      
      return '1';
   }
   // --- test 2 ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // min 3x4
      int i;
      if( get_bw(x0+dx/2, x0+dx/2 , y1-dy/5, y1     ,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2 , y0     , y0+dy/5,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/3, x1-dx/3 , y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;

      if( get_bw(x1-dx/3, x1      , y0+dy/3, y0+dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/9 , y0     , y0     ,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/9, x1      , y0     , y0     ,p,cs,1) == 1 ) break;
      if( get_bw(x0     , x0+dx/18, y1     , y1     ,p,cs,1) != 1 ) break;

      if( num_cross(x0, x1-dx/8, y0+dy/2, y0+dy/2, p,cs) != 1 ) break;

      for( x=x0+dx/4;x<x1-dx/6;x++ )		// C
      if( num_cross( x, x, y0, y1, p,cs) == 3 ) break;
      if( x>=x1-dx/6 ) break;

      for(i=1,y=y0;y<y0+dy/2;y++ )
      if( num_cross( x0, x1, y, y, p,cs) == 2 ) i=0;
      if( i ) break;

      for(i=1,y=y0+dy/5;y<y0+dy/2;y++ )
      if( get_bw( x0, x0+dx/3, y, y, p,cs,1) == 0 ) i=0;
      if( i ) break;

      x=x1-dx/3,y=y1;
      turmite(p,x,y,x0,x1,y0,y1,cs,UP,ST); if( y<y1-dy/5 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,ST,UP); if( y<y1-dy/4 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,UP,ST); if( y<y0+dy/3 ) break; y++;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,ST); if( x<x1 ) break;

      // test ob rechte Kante ansteigend
      for(x=0,y=dy/18;y<=dy/3;y++){ // rechts abfallende Kante/Rund?
        i=loop(b,dx-1,y,dx,cs,0,LE);
        if( i<x ) break;	// rund
        if( i>x ) x=i;
      }
      if (y>dy/3 ) break; 	// z
      if( num_hole( x0, x1, y0, y1, p,cs) > 0 ) break;
      bc='2';
      return bc;
   }
   // --- test 3 -------
   for(d=100;dx>4 && dy>3;){	// dy<=dx nicht perfekt! besser mittleres
				// min-suchen fuer m
      int i,i1,i2,i3,i4;
      if( num_cross(x0+dx/2, x0+dx/2, y0 , y1 ,p,cs) < 2 ) break;
      if( loop(b,dx/2,  0   ,dy,cs,0,DO)>dy/4 ) break;
      if( loop(b,dx/2,  dy-1,dy,cs,0,UP)>dy/4 ) break;
      if( loop(b,dx-1,  dy/3,dy,cs,0,LE)>dy/4 ) break;
      if( loop(b,dx-1,2*dy/3,dy,cs,0,LE)>dy/4 ) break;
      for( i3=x=0,i1=y=dy/5;y<dy/2;y++ ){ // suche erstes >
        i=loop(b,0,y,dx,cs,0,RI);
        if( i>x ) { i3=x=i;i1=y; }
      } i3--; if( i3<dx/2 ) break;
      for( i4=x=0,i2=y=y1;y>dy/2;y-- ){ // suche zweites >
        i=loop(b,0,y,dx,cs,0,RI);
        if( i>x ) { i4=x=i;i2=y; }
      } i4--; if( i4<dx/2 ) break;
      if( get_bw(i3,i3,i1,i2  ,b,cs,1) != 1 ) break;
      if( get_bw(i4,i4,i1,i2  ,b,cs,1) != 1 ) break;
      if( get_bw(i3,i3,0 ,i1  ,b,cs,1) != 1 ) break;
      if( get_bw(i4,i4,i1,dy-1,b,cs,1) != 1 ) break;  // m like
      if( num_hole( x0, x1, y0, y1, p,cs) > 0 ) break;

      return '3';
   }
   // --- test 4 -------
   for(d=100;dx>3 && dy>4;){     // dy>dx
      // --- follow line from left down to right up
      x=x0,y=y0;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,ST); if( x<x1-dx/2 ) break;
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,LE); if( x>=x0 ) break;
      x=x0,y=y0;
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,ST); if( y<y0+dy/2 ) break;
      int i;
      if( get_bw(x0     , x0+dx/2, y1-dy/5, y1-dy/5,p,cs,1) == 1 ) break;
      if( get_bw(x0+dx/2, x1     , y1-dy/3, y1-dy/3,p,cs,1) != 1 ) break;
      if( get_bw(x0+dx/2, x0+dx/2, y0+dy/3, y1-dy/5,p,cs,1) != 1 ) break;
      if( loop(b,b.x-1,  b.y/4,dx,cs,0,LE) >
          loop(b,b.x-1,2*b.y/4,dx,cs,0,LE)+1 ) break;
      for(i=dx/8+1,x=0;x<dx && i;x++){
        if( num_cross(x ,x   ,0  ,dy-1, b,cs) == 2 ) i--;
      } if( i ) break;
      for(i=dy/6+1,y=dy/4;y<dy && i;y++){
        if( num_cross(0 ,dx-1,y  ,y   , b,cs) == 2 ) i--;
      } if( i ) break;
      for(i=dy/10+1,y=dy-1-dy/4;y<dy && i;y++){
        if( num_cross(0   ,dx-1,y ,y  , b,cs) == 1 )
        if( num_cross(dx/2,dx-1,y ,y  , b,cs) == 1 ) i--;
      } if( i ) break;
      bc='4';
      break;
   }
   // --- test 6 -------
   for(d=100;dx>3 && dy>4;){     // dy>dx
      for( y=y0+dy/6;y<=y0+dy/3;y++ )
        if( loop(p,x1,y,dx,cs,0,LE)>dx/2 ) break;
      if( y>y0+dy/3 ) break;
      // --- follow line from left down to right up
      x=x1; // y=y0+dy/4;
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST); if( x>x0+dx/2 ) break;
      x=x0,y=y1-dy/3;
      turmite(p,x,y,x0,x1,y0,y1,cs,RI,ST); if( x>x0+dx/4 ) break;
      x=x1,y=y1-dy/3;
      turmite(p,x,y,x0,x1,y0,y1,cs,LE,ST); if( x<x1-dx/4 ) break;
      x=x0+dx/2,y=y0;
      turmite(p,x,y,x0,x1,y0,y1,cs,DO,ST); if( y>y0+dy/8 ) break;

      if( num_cross(x0+dx/2, x0+dx/2, y0, y1,p,cs) != 3 ) break;
      if( num_hole ( x0, x1, y0+dy/4, y1,p,cs) != 1 ) break; 
      if( num_hole ( x0, x1, y0     , y1,p,cs) != 1 ) break; 
      bc='6';
      break;
   }
   // --- test 7 ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // dx>1 dy>2*dx 
      int i,j;
      for( i=1,y=y0;y<y0+dy/6 && i;y++){ // start oberer Balken?
        if( get_bw(x0+dx/2,x1-dx/12,y,y,p,cs,1) == 1 ) i=0;
      } if( i ) break; // out y
      for( i=1,x=0;y<y0+dy/2 && i;y++){	// lower end of upper Balken?
        if( get_bw(x0,x0+dx/2,y,y,p,cs,1) == 0 ) i=0;
        j=loop(p,x1,y,dx,cs,0,LE); if( j<x ) break; x=j;
      } if( i ) break; // out x
      for( i=1;y<=y1 && i;y++){	// lower end of upper Balken?
        if( num_cross(x0,x1,y,y,p,cs) != 1 ) break;
        j=loop(p,x1,y,dx,cs,0,LE); if( j<x ) break; x=j;
      } if( y<=y1 ) break;
      if ( x<dx/3 ) break;
      // querbalken ueber 50 % der Breite?
      for( i=5*dx/9,x=x0;x<=x1-dx/6 && i;x++){
        j=loop(p,x,y0  ,dy,cs,0,DO); if( j>dy/5 ) continue;
        j=loop(p,x,y0+j,dy,cs,1,DO); if( j<dy/4 ) i--; // thickness <=> ','
      } if( i ) break;
      return '7';
   }
   // --- test 8 ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // dx>1 dy>2*dx 
      int i,j,i1;
      for( x=0,i=y=y0+dy/3;y<=y1-dy/3;y++){	// linke Kerbe
	j=loop(p,x0,y,dx,cs,0,RI); if( j>x ) { x=j; i=y; }
      } if(i>y0+dy/2+dy/20 || x<dx/5 || x>dx/2) break;	// no gB
      j =   loop(p,x1,y1-  dy/4,dx,cs,0,LE);
      if( j>loop(p,x1,y1-  dy/5,dx,cs,0,LE)
       && j>loop(p,x1,y1-2*dy/5,dx,cs,0,LE) ) break;	// &
      if( num_hole(x0,x1,y0,i+1,p,cs)!=1 ) break;	// upper hole
      if( num_hole(x0,x1,i-1,y1,p,cs)!=1 ) break; i1=i; // lower hole
      if( num_cross(x0,x1,y1-dy/4,y1-dy/4,p,cs) != 2 ) break;
      for( x=0,i=y=y0+dy/3;y<=y1-dy/3;y++){
	j=loop(p,x1,y,dx,cs,0,LE); if( j>x ) { x=j; i=y; }
      } if(i>y0+dy/2+dy/10 || x<dx/5 || x>dx/2) break;	// no g
      if(abs(i1-i)>dy/10) break;
      return '8';
   }
   // --- test 9 ---------------------------------------------------
   for(d=100;dx>2 && dy>4;){     // dx>1 dy>2*dx 
      int i,j;
      for( x=0,i=y=y0+dy/3;y<=y1-dy/5;y++){	// suche kerbe
	j=loop(p,x0,y,dx,cs,0,RI); 
        if( j>x ) { x=j; i=y; }
      } if( x<2*dx/3 ) break;
      if( num_cross(x0+dx/2,x0+dx/2,i,y1,p,cs) != 1 ) break;
      if( num_hole(x0,x1,y0,i+1,p,cs)!=1 ) break;
      if( num_hole(x0,x1,i-1,y1,p,cs)!=0 ) break;
      if( loop(p,x0,y1,dy,cs,0,RI)>dx/3) break; // no q
      for( x=0,i=y=y0+dy/3;y<=y1-dy/3;y++){	// suche kerbe
	j=loop(p,x1,y,dx,cs,0,LE); 
        if( j>x ) { x=j; i=y; }
      } if( x>dx/2 ) break;		// no g
      if( get_bw(x1,x1,y0+dy/3,y0+dy/2,p,cs,1) == 0 )
      if( get_bw(x1,x1,y0     ,y0+dy/3,p,cs,1) == 1 ) break; // schreib g
      return '9';
   }
   // --- test ()<> ------------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      int i,i1,i2,i3,i4,i5,i6;  if( dots ) break;
      for(i=1,y=0;y<dy && i;y++){
        if( num_cross(0,dx-1,y,y,b,cs) != 1 ) i=0;
        if( loop(b,   0,y,dx,cs,0,RI)
          + loop(b,dx-1,y,dx,cs,0,LE)<5*dx/8 ) i=0;
      } if( !i ) break;
      i1=loop(b,dx-1,0   ,dx,cs,0,LE);
      i2=loop(b,dx-1,dy/2,dx,cs,0,LE);
      i3=loop(b,dx-1,dy-1,dx,cs,0,LE);
      i4=loop(b,   0,0   ,dx,cs,0,RI);
      i5=loop(b,   0,dy/2,dx,cs,0,RI);
      i6=loop(b,   0,dy-1,dx,cs,0,RI);
      if(i2<=dx/10 && i4<=dx/10 && i6<=dx/10) return ((dx>dy)?'>':')');
      if(i5<=dx/10 && i1<=dx/10 && i3<=dx/10) return ((dx>dy)?'<':'(');
      if(i1<=dx/10 && i2>dx/3 && i5>dx/3 && i6<=dx/10) return '/';
      if(i4<=dx/10 && i2>dx/3 && i5>dx/3 && i3<=dx/10) return '\\';
      break;
   }
   // --- test + ------------------------------------------------
   for(d=100;dx>2 && dy>2;){     // min 3x4
      int i;
      if( get_bw(x0,x0+dx/3,y0,y0+dy/3,p,cs,1) == 1 ) break;
      if( get_bw(x0,x0+dx/4,y1-dy/4,y1,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/4,x1,y0,y0+dy/4,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/3,x1,y1-dy/3,y1,p,cs,1) == 1 ) break;
      for(i=1,y=y0+dy/3;y<=y1-dy/3 && i;y++) // waagerechter strich?
        if( get_bw(x0+dx/9,x1-dx/9,y,y,p,cs,2) == 0 ) i=0;
      if( i ) break;
      return '+';
   }
   // --- test $ ------------------------------------------------
   for(d=100;dx>3 && dy>5;){     // min 3x4
      int i,i1,i2;
      if( num_hole(x0,x1,y0,y1,p,cs)!=2 ) break;
      
      if( get_bw(x0,x0+dx/5,y0      ,y0+dy/18,p,cs,1) == 1 ) break;
      if( get_bw(x0,x0+dx/9,y1-dy/23,y1      ,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/9,x1,y0      ,y0+dy/18,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/5,x1,y1-dy/23,y1      ,p,cs,1) == 1 ) break;
      if( get_bw(x0,x0+dx/3,y0+dy/3 ,y0+dy/2 ,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/3,x1,y1-dy/2 ,y1-dy/3 ,p,cs,1) != 1 ) break;
      i1=x0+loop(p,x0,y0,dx,cs,0,RI); if( i1<x0+dx/3 || i1>x1-dx/5 ) break;
      i2=x0+loop(p,x0,y1,dx,cs,0,RI); if( i2<x0+dx/5 || i2>i1      ) break;
      for(i=1,y=y0;y<=y1 && i;y++) // vertikaler strich?
        if( get_bw(i2,i1+2,y,y,p,cs,1) != 1 ) i=0;
      if( !i ) break;
      return '$';
   }
   // --- test & ------------------------------------------------
   for(d=100;dx>5 && dy>6;){
      if( get_bw(x1-dx/9,x1,y0,y0+dy/4,p,cs,1) == 1 ) break; // g
      if( num_hole(x0,x1     ,y0,y1,p,cs)!=2 ) break;
      if( num_hole(x0,x1-dx/3,y0,y1,p,cs)!=2 ) break;
      return '&';
   }
   // --- test ? ---------------------------------------------------
   for(d=100;dx>3 && dy>4;){     // min 3x4
      int i;
      if ( bc!='_' ) return bc;
      // out_b(p,x0,y0,dx,dy,cs);
      for(y=y0;y<y1;y++)	// new y1
      if( get_bw(x0, x1, y, y,p,cs,1) != 1 ) break; // lower end upper point
      if( y==y1 ) break; y--; i=y-y0+1;	// new dy
      // printf(" ?test y=%d i=%d\n",y-y0,i);
      if( get_bw(x0+dx/2, x0+dx/2 , y0    , y0+i/5,p,cs,1) != 1 ) break;
      if( get_bw(x0     , x0+dx/8 , y -i/3, y -i/4,p,cs,1) == 1 ) break;
      if( get_bw(x0     , x0+dx/6 , y -i/4, y     ,p,cs,1) == 1 ) break;
      if( get_bw(x1-dx/3, x1      , y0+i/5, y0+i/2,p,cs,1) != 1 ) break;
      if( get_bw(x1-dx/4, x1      , y -i/4, y     ,p,cs,1) == 1 ) break;
      if( num_cross(x0     , x1     , y     , y     , p,cs) != 1 ) break;
      if( num_cross(x0+dx/5, x1-dx/3, y     , y     , p,cs) != 1 ) break;
      if( num_cross(x0+dx/3, x1-dx/3, y -i/4, y -i/4, p,cs) != 1 ) break;
      if( num_hole( x0, x1, y0, y1, p,cs) > 0 ) break;
      bc='?';
      return bc;
   }
   // --- test !| ---------------------------------------------------
   for(d=100;dx>2 && dy>3 && dy>2*dx;){     // min 3x4
     int i,i1;
	// measure thickness
 
     for( i1=0,y=y0;y<=y1;y++){
       i=num_cross(x0,x1,y,y,p,cs); if(i>1) break;
       if(i==0 && i1==0) i1=y;
     } if(y<=y1 || i1==0 || i1<y0+dy/2)break;

     return '!'; 
   }
   // --- test * five egdes (jagges? beames?) what is the right english word? ----
   for(d=100;dx>4 && dy>4;){
      int i; 
      x=dx/2;y=(6*dy+8)/16; // center point 6/8=6/2^3 rounded 
      i=get_line2(x,y,x   ,0,b,cs,100); if(i<95) break; // black upwarts beam
      i=get_line2(0,y,dx-1,y,b,cs,100); if(i<95) break; // horizontal line
//      out_b(b,0,0,dx-1,dy-1,cs);printf(" %d",(5*dx+4)/8);
      i=get_line2(x,y,(5*dx+4)/8,dy-1,b,cs,100); if(i<95) break; // straight down
      i=get_line2(x,y,(2*dx+4)/8,dy-1,b,cs,100); if(i<95) break; // straight up
      i=get_line2(     x,dy-dy/8,x,dy-1,b,cs,101); if(i<95) break; // lower gap
      i=get_line2(     dx/4,dy/4,   0,0,b,cs,101); if(i<95) break; // upper left gap
      i=get_line2(dx-1-dx/4,dy/4,dx-1,0,b,cs,101); if(i<95) break; // upper right gap
      return '*';
   }
#endif
   return bc;
}
