#define Version "v0.2.1  2000/03/14"
/*
This is a Optical-Character-Recognition program
Copyright (C) 2000  Joerg Schulenburg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 Joerg.Schulenburg@physik.uni-magdeburg.de

*/
//
// - v0.2    add line scanning 160h Dez98-Mai99
// - v0.2.1  good images <2%   100h Mar00-Mar00
//
//  sometimes I have written comments in german language, sorry for that
//
// - look for ??? for preliminary code
// - space: avX=22 11-13
//          avX=16  5-7
//          avX= 7  5-6
//         
// ToDo: - write parallelizable code!
//       - learnmode
//       - use ispell for final control
//       - better line scanning (if not even)
/*  GLOBAL DATA (mostly structures)
   - pix   : image - one byte per pixel  bits0-2=working
   - lines : rows of the text (points to pix)
   - box   : list of bounding box for character 
   - obj   : objects (lines, splines, etc. building a character)
 */


#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
// #include <malloc.h>	// wegen Probleme mit delete ???

#include "pgm2asc.h"
#include "pcx.h"
#include "ocr1.h" 	// ocr r (test new versions)
#include "ocr0.h" 	// ocr 0-9 a-z A-Z "a "o "u "A "O "U

#define Uint  unsigned int
#define Uchar unsigned char
#define mmax(x,y)  (((x)>(y))?(x):(y))

// ostream& operator << ( ostream &os, int &i ){
//  os << " " << setprecision(4) << i; return os; }

// ---------------------------------------------------------------------
// list of letter boxes (root+end or end==root)
// ---------------------------------------------------------------------
struct box *box1=(struct box*)NULL,*box2;	// root, temp
struct environment env = {cs:160,avX:5,avY:8};
struct tlines lines;

int n_run=0;  // num of run, if run_2 critical pattern get other results
              // used for 2nd try, pixel uses slower filter function etc.

int in_str(char c, char *s){
  int i;
  for(i=0;s[i]!=0 && i<100;i++) if( s[i]==c ) return i+1;
  return 0;
}

// for sorting letters
// ToDo: - use function same line like this or include lines.m1 etc. 
int box_gt(struct box *box1,struct box *box2){  // box1 after box2 ?
      if(  box1->line > box2->line ) return 1;
      if(  box1->line < box2->line ) return 0;
      if(  box1->x0 > box2->x1  ) return 1; // before
      if(  box1->x1 < box2->x0  ) return 0; // before
      if(  box1->x0 > box2->x0  ) return 1; // before  ueberlappend!
      return 0;
}
void box_del(struct box *box2){		// delete b2 from list
  if(box2->pre ) box2->pre->next=box2->next;
  if(box2->next) box2->next->pre=box2->pre;
  if(box1==box2) box1=box2->next;
}
void box_ins_before(struct box *box2,struct box *box3){ // insert b3 before b2 in list
  if(box1==NULL) { box1=box3;box3->next=box3->pre=(struct box*)NULL;return; }
  box3->pre =box2->pre;
  box2->pre =box3;
  box3->next=box2;
  if(box3->pre){
    assert(box3->pre->next==box2);
    box3->pre->next=box3;
  }
  if(box1==box2) box1=box3;
}

void box_app(struct box **box1,struct box *box3){ // append b3 on list box1
  assert(box3);			// must be a non NULL pointer from new()
  if(*box1==NULL){ *box1=box3;box3->next=box3->pre=(struct box*)NULL;return; }
  struct box *box2=*box1;while(box2->next) box2=box2->next; // search end
  box3->pre =box2;
  box2->next=box3;
  box3->next=(struct box*)NULL;
}
// ------------------------ end list-funcs --------------------------
// ------------------ (&~7)-pixmap-functions ------------------------
 
// test if pixel marked?
int marked(pix &p, int  x, int  y){	// ret: 0=not_marked
  if( x<0 || y<0 || x>=p.x || y>=p.y ) return 255 & 7;
  return( p.p[x+y*p.x] & 7 ); }

// test if pixel --- later with error-correction
int pixel(pix &p, int x, int y){	// ret: pixel-color (without marks)
  if( x<0 || y<0 || x>=p.x || y>=p.y ) return 255 & ~7;
  if((n_run&1) && x>0 && y>0 && x+1<p.x && x+1<p.y){ int r; // filter
    r=(12*p.p[x+y*p.x]+p.p[x+1  +y*p.x]+p.p[x-1  +y*p.x]
                      +p.p[x+(y+1)*p.x]+p.p[x+(y-1)*p.x])/16;
    return r & ~7;
  }
  return( p.p[x+y*p.x] & ~7 ); }

/* modify pixel, test for out of range */
void put(pix &p,int x,int y,int ia,int io){
 if(x<p.x && x>=0 && y>=0 && y<p.y)
 p.p[x+y*p.x]=(p.p[x+y*p.x] & ia) | io;
 return;}

void out_b(pix &b, int x0, int y0, int dx, int dy, int cs ){
  int x,y; static char *c1="OXXXXxx@",
                       *c2=".,,,,,,,";
  printf("# list pattern   x=%4d %4d d=%3d %3d\n",x0,y0,dx,dy);
  for(y=y0;y<y0+dy;y++) {
    for(x=x0;x<x0+dx;x++) 
    printf("%c", ((pixel(b,x,y)<cs)?c1[marked(b,x,y)]
                                   :c2[marked(b,x,y)]));
    if ( dx>0 ) printf("\n");
  }
}

void out_b2(pix &b, int x0, int y0, int dx, int dy, int cs, int x1, int y1 ){
  int x,y; static char *c1="OXXXXxx@",
                       *c2=".,,,,,,,";
  printf(" x=%5d %5d  d=%5d %5d\n",x0,y0,dx,dy);
  for(y=y0;y<y0+dy;y++) {
    for(x=x0;x<x0+dx;x++) 
    printf("%c", ((pixel(b,x,y)<cs)?c1[marked(b,x,y)]
                                   :c2[marked(b,x,y)]));
    if( dx>0 ) printf(" = ");
    for(x=x1;x<x1+dx;x++) 
    printf("%c", ((pixel(b,x,y+y1-y0)<cs)?c1[marked(b,x,y+y1-y0)]
                                         :c2[marked(b,x,y+y1-y0)]));
    if ( dx>0 ) printf("\n");
  }
}
// ------------------------ feature extraction -----------------
// -------------------------------------------------------------
// detect maximas in of line overlapps (return in %) and line koord
#define HOR 1    // horizontal
#define VER 2    // vertikal
#define RIS 3    // rising=steigend
#define FAL 4    // falling=fallend
struct tline line;


void swap(int *a,int *b){ int c=*a;*a=*b;*b=c; }

// kalkulate the overlapp of the line (0-1) with black points 
// by rekursiv bisection 
// gerade y=dy/dx*x+b, implizit d=F(x,y)=dy*x-dx*y+b*dx=0 
// incrementell y(i+1)=m*(x(i)+1)+b, F(x+1,y+1)=f(F(x,y))
// ret & 1 => inverse pixel!
// d=2*F(x,y) ganze Zahlen
int get_line(int x0, int y0, int x1, int y1, pix p, int cs, int ret){
   int dx,dy,incrE,incrNE,d,x,y,r0,r1,ty,tx,
       *px,*py,*pdx,*pdy,*ptx,*pty,*px1;
   dx=abs(x1-x0); tx=((x1>x0)?1:-1);    // tx=x-spiegelung (new)  
   dy=abs(y1-y0); ty=((y1>y0)?1:-1);	// ty=y-spiegelung (new)
   // rotate coordinate system if dy>dx
   if(dx>dy){ pdx=&dx;pdy=&dy;px=&x;py=&y;ptx=&tx;pty=&ty;px1=&x1; }
   else     { pdx=&dy;pdy=&dx;px=&y;py=&x;ptx=&ty;pty=&tx;px1=&y1; }
   if( *ptx<0 ){ swap(&x0,&x1);swap(&y0,&y1);tx=-tx;ty=-ty; }
   d=(*pdy)*2-(*pdx); incrE=(*pdy)*2; incrNE=((*pdy)-(*pdx))*2;  
   x=x0; y=y0; r0=r1=0; /* dd=tolerance (store max drift) */
   while( (*px)<=(*px1) ){ 
     if( ((pixel(p,x,y)<cs)?1:0)^(ret&1) ) r0++; else r1++;
     (*px)++; if( d<=0 ){ d+=incrE; } else { d+=incrNE; (*py)+=(*pty); }
   }
   return (r0*(ret&~1))/(r0+r1); // ret==100 => percentage %
}

// ret & 1 => inverse pixel!
// d=2*F(x,y) ganze Zahlen
int get_line2(int x0, int y0, int x1, int y1, pix p, int cs, int ret){
   int dx,dy,incrE,incrNE,d,x,y,r0,r1,ty,tx,q,
       *px,*py,*pdx,*pdy,*ptx,*pty,*px1;
   dx=abs(x1-x0); tx=((x1>x0)?1:-1);    // tx=x-spiegelung (new)  
   dy=abs(y1-y0); ty=((y1>y0)?1:-1);	// ty=y-spiegelung (new)
   // rotate coordinate system if dy>dx
   if(dx>dy){ pdx=&dx;pdy=&dy;px=&x;py=&y;ptx=&tx;pty=&ty;px1=&x1; }
   else     { pdx=&dy;pdy=&dx;px=&y;py=&x;ptx=&ty;pty=&tx;px1=&y1; }
   if( *ptx<0 ){ swap(&x0,&x1);swap(&y0,&y1);tx=-tx;ty=-ty; }
   d=(*pdy)*2-(*pdx); incrE=(*pdy)*2; incrNE=((*pdy)-(*pdx))*2;  
   x=x0; y=y0; r0=r1=0;
   while( (*px)<=(*px1) ){ 
     q=((pixel(p,x,y)<cs)?1:0)^(ret&1);
     if ( !q ){		// tolerance
       (*py)+=1;q|=((pixel(p,x,y)<cs)?1:0)^(ret&1);
       (*py)-=2;q|=((pixel(p,x,y)<cs)?1:0)^(ret&1);
       (*py)+=1;
     }
     if( q ) r0++; else r1++;
     (*px)++; if( d<=0 ){ d+=incrE; } else { d+=incrNE; (*py)+=(*pty); }
   }
   return (r0*(ret&~1))/(r0+r1); // ret==100 => percentage %
}

// look for white 2 or black 1 dots (3 = white+black)
char get_bw(int x0, int x1, int y0, int y1,
             pix p, int cs,int mask){
  char rc=0;			// later with error < 2% (1 dot)
  if(x0< 0  ) x0=0;  if(x1>=p.x) x1=p.x-1;
  if(y0< 0  ) y0=0;  if(y1>=p.y) y1=p.y-1;
  for(int y=y0;y<=y1;y++)
  for(int x=x0;x<=x1;x++){
    if( pixel(p,x,y)<cs) rc|=1; else rc|=2;	// break if rc==3
    if( (rc & mask)==mask ) return mask;	// break loop
  }
  return(rc & mask);
}
// count black part of a line (modulo w)
int get_line3(int x0, int x1, int y0, int y1, pix p,int cs,int w){
  int rc=0,x,y,i,d,ww;		// rc=crossings  col=0=white
  int dx=x1-x0, dy=y1-y0;
  if( abs(dx)>=abs(dy) ) d=abs(dx); else d=abs(dy);
  if(d)for(ww=i=0,x=x0,y=y0; i<=d; i++){
    x=x0+i*dx/d; y=y0+i*dy/d;
    if( ((pixel(p,x,y)<cs)?1:0) ) ww=w;	// 0=white 1=black
    if (ww) { ww--;rc++; }
  } 
  return rc;
}
// more general Mar2000 (x0,x1,y0,y1 instead of x0,y0,x1,y1! (history))
// look for black crossing a line x0,y0,x1,y1
// follow line and count crossings ([white]-black-transitions)
int num_cross(int x0, int x1, int y0, int y1, pix p,  int cs){
  int rc=0,col=0,k,x,y,i,d;		// rc=crossings  col=0=white
  int dx=x1-x0, dy=y1-y0;
  if( abs(dx)>=abs(dy) ) d=abs(dx); else d=abs(dy);
  for(i=0,x=x0,y=y0; i<=d; i++){
    if(d){ x=x0+i*dx/d; y=y0+i*dy/d; }
    k=((pixel(p,x,y)<cs)?1:0);	// 0=white 1=black
    if(col==0 && k==1) rc++; col=k;
  } 
  return rc;
}
// -------------------------------------------------------------
// mark edge-points
//  - first move forward until b/w-edge
//  - more than 2 pixel?
//  - loop around
//    - if forward    pixel : go up, rotate right
//    - if forward no pixel : rotate left
//  - stop if found first 2 pixel in same order
// mit an rechter-Wand-entlang-gehen strategie
// --------------------------------------------------------------
// turmite game: inp: start-x,y, regel r_black=UP,r_white=RIght until border
//               out: last-position
// Zaehle dabei, Schritte,Sackgassen,xmax,ymax,ro-,ru-,lo-,lu-Ecken
//
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// GUTE IDEE VON MIR!!! KI-Methode!!! oder nicht???
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
void turmite(pix &p, int &x, int &y, 
             int x0, int x1, int y0, int y1, int cs, int rw, int rb){
  int r;
  if( x0<0  || y0<0  || x1>=p.x || y1>=p.y ) return;	// out of pixmap
  for(;;){
    if( x<x0 || y<y0 || x>x1  || y>y1  ) break;		// out of box
    r = ( (pixel(p,x,y)<cs) ? rb : rw );		// select rule 
    if( r==UP ) y--;   else
    if( r==DO ) y++;   else
    if( r==RI ) x++;   else
    if( r==LE ) x--;   else
    if( r==ST ) break; else assert(0);
  }
}

// search a way from p0 to p1 without crossing pixels of type t
//  only two directions, usefull to test if there is a gap 's'
// labyrint algo - do you know a faster way?
int joined(pix &p, int x0, int y0, int x1, int y1, int cs){
  int t,r,x,y,dx,dy,xa,ya,xb,yb;
  x=x0;y=y0;dx=1;dy=0;
  if(x1>x0){xa=x0;xb=x1;}else {xb=x0;xa=x1;}
  if(y1>y0){ya=y0;yb=y1;}else {yb=y0;ya=y1;}
  t=((pixel(p,x,y)<cs)?1:0);
  for(;;){
    if( t==((pixel(p,x+dy,y-dx)<cs)?1:0)	// right free?
     && x+dy>=xa && x+dy<=xb && y-dx>=ya && y-dx<=yb) // wall
         { r=dy;dy=-dx;dx=r;x+=dx;y+=dy; } // rotate right and step forward
    else { r=dx;dx=-dy;dy=r; } // rotate left
    // printf(" path %d %d  %d %d\n",x,y,dx,dy);
    if( x==x1 && y==y1 ) return 1;
    if( x==x0 && y==y0 && dx==1) return 0;
  }
  return 0; // endless loop ?
}

// move from x,y to direction r until pixel==col or l steps
// return number of steps
int loop(pix &p,int x,int y,int l,int cs,int col,int r){ int i;
  static const int rr[5][2]={{0,0},{0,-1},{0,1},{1,0},{-1,0}};
  for(i=0;i<l && x>=0 && y>=0 && x<p.x && y<p.y;i++){
    if( ((pixel(p,x,y)<cs)?1:0)^col ) break;
    x+=rr[r][0]; y+=rr[r][1];
  }
  return i;
}
// mark recursiv if no-pixel-neighbours=0 connected with (x,y)
// better with neighbours of same color (more general) ???
// (&~7)-pixmap, start-point, critical_value, mark
// mark neighbouring pixel of same color, return number
int mark_nn(pix &p, int  x, int  y, int &cs, int r){
  if( x<0 || y<0 || x>=p.x || y>=p.y) return 0;	// out of limits
  if( marked(p,x,y) ) return 0;		// already marked
  p.p[x+y*p.x] |= (r&7);		// mark (better direction)
  int  rc=1;
  int  i=((pixel(p,x  ,y  )<cs)?0:1);
  if( i==((pixel(p,x+1,y  )<cs)?0:1) ) rc+=mark_nn(p,x+1,y  ,cs,r);
  if( i==((pixel(p,x-1,y  )<cs)?0:1) ) rc+=mark_nn(p,x-1,y  ,cs,r);
  if( i==((pixel(p,x  ,y+1)<cs)?0:1) ) rc+=mark_nn(p,x  ,y+1,cs,r);
  if( i==((pixel(p,x  ,y-1)<cs)?0:1) ) rc+=mark_nn(p,x  ,y-1,cs,r);
  if(n_run&1){ // second run
    // diag-code added Mai99
    // if( i==1 ) return rc; // only one color diagonal
    if( i==((pixel(p,x+1,y+1)<cs)?0:1) ) rc+=mark_nn(p,x+1,y+1,cs,r);
    if( i==((pixel(p,x-1,y-1)<cs)?0:1) ) rc+=mark_nn(p,x-1,y-1,cs,r);
    if( i==((pixel(p,x-1,y+1)<cs)?0:1) ) rc+=mark_nn(p,x-1,y+1,cs,r);
    if( i==((pixel(p,x+1,y-1)<cs)?0:1) ) rc+=mark_nn(p,x+1,y-1,cs,r);
  }
  return rc;
}
// use lowest three bits for mark
void frame_nn(pix &p,  int  x,  int  y,
              int &x0, int &x1, int &y0, int &y1,	// enlargeframe
              int cs, int r){
  if( x<0 || y<0 || x>=p.x || y>=p.y) return;	// out of limits
  if( marked(p,x,y) ) return;		// already marked
  p.p[x+y*p.x] |= (r&7);		// mark (better direction)
  if(x<x0) x0=x;  if(x>x1) x1=x;
  if(y<y0) y0=y;  if(y>y1) y1=y;
  int  i=((pixel(p,x  ,y  )<cs)?0:1);
  if( i==((pixel(p,x+1,y  )<cs)?0:1) ) frame_nn(p,x+1,y  ,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x-1,y  )<cs)?0:1) ) frame_nn(p,x-1,y  ,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x  ,y+1)<cs)?0:1) ) frame_nn(p,x  ,y+1,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x  ,y-1)<cs)?0:1) ) frame_nn(p,x  ,y-1,x0,x1,y0,y1,cs,r);
  // diag-code added Mai99
  if( i==((pixel(p,x+1,y+1)<cs)?0:1) ) frame_nn(p,x+1,y+1,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x-1,y-1)<cs)?0:1) ) frame_nn(p,x-1,y-1,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x-1,y+1)<cs)?0:1) ) frame_nn(p,x-1,y+1,x0,x1,y0,y1,cs,r);
  if( i==((pixel(p,x+1,y-1)<cs)?0:1) ) frame_nn(p,x+1,y-1,x0,x1,y0,y1,cs,r);
}
// clear lowest 3 (marked) bits 
void clr_bits(pix &p, int x0, int x1, int y0, int y1){ int x,y;
  for(y=y0;y<=y1;y++)
  for(x=x0;x<=x1;x++)  p.p[x+y*p.x] &= ~7;
}

// --- copy part of pix p into new pix b	---- len=10000
int copybox( pix p, int x0, int y0, int dx, int dy, pix *b, int len){
  int x,y;  b->x=b->y=0;
  if(b->p==NULL || dx<0 || dy<0 || dx*dy>len){
    printf(" error-copybox x=%5d %5d  d=%5d %5d\n",x0,y0,dx,dy);
    return 1;
  }
  b->x = dx;   b->y = dy;   b->bpp = 1;
  for(x=0;x<dx;x++)
  for(y=0;y<dy;y++) b->p[x+y*dx] = pixel(p,x+x0,y+y0);
  return 0;
}

// look for white holes surrounded by black points
// at moment white point with black in all for directions
int num_hole(int x0, int x1, int y0, int y1, pix p, int cs){
  int rc=0,x,y;			// rc:1=hole
  static Uchar buf[10000];	// oder 2nd copy of picture, for working 
  pix b;			// temporary mini-page
  int dx=x1-x0+1, dy=y1-y0+1;
  b.p = buf;
//  b.p = new Uchar[ dy*dx ]; 	// buffer
//  b.p = (Uchar *)malloc(dy*dx);
//  assert(b.p);
  if( copybox(p,x0,y0,dx,dy,&b,10000) ) return -1;
  // --- mark white-points connected with border        // if(opt&1)
  for(x=0;x<b.x;x++) if(pixel(b,x,    0)>=cs) mark_nn(b,x,    0,cs,AT);		// erweiterung:
  for(x=0;x<b.x;x++) if(pixel(b,x,b.y-1)>=cs) mark_nn(b,x,b.y-1,cs,AT);		//  nur optional		
  for(y=0;y<b.y;y++) if(pixel(b,0    ,y)>=cs) mark_nn(b,0    ,y,cs,AT);		//  ist wie
  for(y=0;y<b.y;y++) if(pixel(b,b.x-1,y)>=cs) mark_nn(b,b.x-1,y,cs,AT);		// zusaetzl.linie
  // out_b(b,0,0,b.x,b.y,cs);
  // --- look for unmarked white points => hole
  for(x=0;x<b.x;x++)
  for(y=0;y<b.y;y++) if( !marked(b,x,y)   )		// unmarked
                     if( pixel(b,x,y)>=cs )		// hole found
		     { if( mark_nn(b,x,y,cs,AT)>1 || dx*dy<=40) rc++; }	
//  delete[] b.p;		// segmentation fault
//  free(b.p);
  return rc;
}

// count for black nonconnected objects --- used for i,auml,ouml,etc.
int num_obj(int x0, int x1, int y0, int y1, pix  p, int cs){
  int x,y,rc=0;			// rc=num_obj
  static Uchar buf[10000];	// oder 2nd copy of picture, for working
  pix b;
  b.p = buf;
  if( copybox(p,x0,y0,x1-x0+1,y1-y0+1,&b,10000) ) return -1;
  // --- mark black-points connected with neighbours
  for(x=0;x<b.x;x++) 
  for(y=0;y<b.y;y++) if( pixel(b,x,y) < cs )
                     if( !marked(b,x,y)    ){
    rc++; mark_nn(b,x,y,cs,AT);
  }
  return rc;
}

// ----------------------------------------------------------------------
// filter-funktionen um bestimmte Buchstaben auszuschliessen
// wenn Elemente aus A+B nicht ausgeschlossen 
// entferne alle Elemente A (B) aus Gruppe zulaessiger
char *list="0123456789,.\0xe4\0xf6\0xfc"	// "a=228 o=246 u=252
           "abcdefghijklmnopqrstuvwxyz"
           "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
int  wert[100];
int  listlen=0,numrest=0;
void ini_list(){ int i;
    for(i=0;list[i]!=0 && i<100;i++) wert[i]=0;
    numrest=listlen=i; } 
void excude(char *filt){ int i,j;
    for(j=0;filt[j]!=0 && j<100;j++)
    for(i=0;list[i]!=0 && i<100;i++)
    if( filt[j]==list[i] ) { if(!wert[i])numrest--; wert[i]++; } }
char getresult(){ int i;
    if( numrest==1 )
    for(i=0;list[i]!=0 && i<100;i++) if(!wert[i]) return list[i];
    return '_';
 }

// 100% * Abstand, 0 is best fit
// = Aehnlichkeit 2er Buchstaben fuer Erkennung verstuemmelter Zeichen
//   weigth of pixels with only one same neighbour set to 0
//   look at contours too!
int distance(   pix p1, int x1, int y1, int dx, int dy,	// box-frame
		pix p2, int x2, int y2, int cs){
   int rc=0,x,y,v1,v2,i1,i2,rgood=0,rbad=0;
   for( y=0;y<dy;y++ )
   for( x=0;x<dx;x++ ) {	// try global shift too ???
     v1     =((pixel(p1,x1+x  ,y1+y  )<cs)?1:0); i1=8;	// better gray?
     if( v1==((pixel(p1,x1+x+1,y1+y  )<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x-1,y1+y  )<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x  ,y1+y+1)<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x  ,y1+y-1)<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x+1,y1+y+1)<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x-1,y1+y-1)<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x-1,y1+y+1)<cs)?1:0) )i1++;else i1--;
     if( v1==((pixel(p1,x1+x+1,y1+y-1)<cs)?1:0) )i1++;else i1--;
     if(i1<2) continue;
     v2     =((pixel(p2,x2+x  ,y2+y  )<cs)?1:0); i2=8;	// better gray?
     if( v2==((pixel(p2,x2+x+1,y2+y  )<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x-1,y2+y  )<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x  ,y2+y+1)<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x  ,y2+y-1)<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x+1,y2+y+1)<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x-1,y2+y-1)<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x-1,y2+y+1)<cs)?1:0) )i2++;else i2--;
     if( v2==((pixel(p2,x2+x+1,y2+y-1)<cs)?1:0) )i2++;else i2--;
     if(i2<2) continue;
     if(v1==v2) rgood+=i1*i2; else rbad+=i1*i2;
   }
   if(rgood+rbad) rc= 100*rbad/(rgood+rbad); else rc=100;
//   printf(" distance rc=%d\n",rc);
   return rc;
}

// ============================= EXPERTEN-SYSTEM ================== ;)
char whatletter(struct box *box1,
                int xa, int ya, 	 		// startpos
                int x0, int x1, int y0, int y1,		// box-frame
                pix  p, int cs, int dots){  // dots ignored since v0.2

   int	x,y;			// besterror
   int  dx=x1-x0+1,dy=y1-y0+1;	// size
   char	bc='_';				// bestletter
   char um=' ';				// umlaut? '"
   if( pixel(p,xa,ya)>=cs || 2*ya<y0+y1){    // bad startpoint (from divide)
     for(y=y1;y>=y0;y--) // low to high (not i-dot)
     for(x=x0;x<=x1;x++) 
     if(pixel(p,x,y)<cs){ xa=x;ya=y;x=x1+1;break; }
   }
   // int vol=(y1-y0+1)*(x1-x0+1);	// volume
   // crossed l-m 
   while( get_bw(x0,x1,y0,y0,p,cs,1)!=1  &&  y0+1<y1) y0++;
   while( get_bw(x0,x1,y1,y1,p,cs,1)!=1  &&  y0+1<y1) y1--;
   dx=x1-x0+1;
   dy=y1-y0+1;	// size

   // --- test for german umlauts and points above
   if( dx>2 && dy>4 )
   if((num_obj(x0,x1,y0,y1       ,p,cs) > 2 
    && num_obj(x0,x1,y0,y0+dy/2  ,p,cs) > 2 
    && num_obj(x0,x1,y0,y0+dy/6+1,p,cs) == 2 ))
   {
     dots=2;um='\"';
     // may be the following lines are not quite ok
     while( num_obj(x0,x1,y0,y1,p,cs)>1  &&  y0+1<y1) y0++;
   }
   if( dy>4 )  // detect only ij dots
   if(( get_bw(x0,x1,box1->m2-1,box1->m2-1,p,cs,1)==0 
     || get_bw(x0,x1,box1->m2-2,box1->m2-2,p,cs,1)==0 ) &&
      (num_obj(x0,x1,box1->m1,box1->m1+3*(box1->m2-box1->m1)/4,p,cs) == 1
    && num_obj(x0,x1,y0,y1,p,cs) == 2 ))
   { dots=1;um='\''; }
   // move upper and lower border (for divided letters)
   while( get_bw(x0,x1,y0,y0,p,cs,1)==0  &&  y0+1<y1) y0++;
   while( get_bw(x0,x1,y1,y1,p,cs,1)==0  &&  y0+1<y1) y1--;
   while( get_bw(x0,x0,y0,y1,p,cs,1)==0  &&  x0+1<x1) x0++;
   while( get_bw(x1,x1,y0,y1,p,cs,1)==0  &&  x0+1<x1) x1--;
   dx=x1-x0+1;
   dy=y1-y0+1;	// size

   // ----- create char-only-box -------------------------------------
   static Uchar buf[10000];	// oder 2nd copy of picture, for working
   pix b;
   b.p = buf;
   if( copybox(p,x0,y0,dx,dy,&b,10000) ) return bc;
   mark_nn(b,xa-x0,ya-y0,cs,1);		// <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   for(x=0;x<b.x;x++) 
   for(y=0;y<b.y;y++) if(!marked(b,x,y)) b.p[x+y*b.x] = 255&~7;

   bc = ocr1(box1, x0, x1, y0, y1,	// box-frame in p
             p, b, cs, dots);	// see ocr1.cc

   if( bc=='_' )
   bc = ocr0(box1, x0, x1, y0, y1,	// box-frame in p
             p, b, cs, dots);	// see ocr0.cc
   if( bc=='_' ){
//     out_b(b,0,0,b.x,b.y,cs);
//     out_b(p,x0,y0,b.x,b.y,cs);
//     printf(" a= %d %d\n",xa,ya);
     n_run++;
     bc = ocr0(box1, x0, x1, y0, y1,	// box-frame in p
               p, b, cs, dots);	// see ocr0.cc
     n_run--;
   }

   if( um=='\"' ){
     if( bc=='a' ) bc=228;
     if( bc=='A' ) bc=196;
     if( bc=='o' ) bc=246;
     if( bc=='O' ) bc=214;
     if( bc=='u' ) bc=252;
     if( bc=='U' ) bc=220;
   }

   return bc;
}

// test if char c in string cset
int strc(char c, char *cset){
  for(int i=0;cset[i] && i<10;i++)
    if(cset[i]==c) return 1;
  return 0;
}

void help(){
    printf( "# Optical Character Recognition gocr "Version"\n# options:\n"
            "# -i string - image file (pnm,pgm,pbm,ppm,pcx)\n"
            "# -l num    - grey level 0<160<=255\n"
            "# -s num    - spacewidth/dots (0 = autodetect)\n"
            "# -v num    - verbose  [summed]\n"
            "#      1      print more info\n"
            "#      2      list chapes  of boxes (see -c)\n"
            "#      4      list pattern of boxes (see -c)\n"
            "#      8      print pattern after recognition\n"
            "#     16      print line infos\n"
            "#     32      debug outXX.pgm\n"
            "# -c string - list of chars (_ = not recognized chars)\n"
            "# -m num    - operation modes\n"
            "#      8      ~ compare non recognized chars\n"
            "#     16      ~ divide overlapping chars\n"
            "#     64      char packing\n"
            "# example: gocr -v 6 -v 32 -c _YV -i text1.pgm\n");
    exit(0);
}

// -------------------------------------------------------------
// ------             MAIN 
// -------------------------------------------------------------
int main(int argn, char *argv[]){
  int i,x,y,vvv=0,cs=0,spc=0,plothisto=0,mo=0;
  int sumX=0,sumY=0;		// average size => sumX/numC,sumY/numC
  int numC=0;
  pix p,p2;
  char *inam="text.pgm",cc=0,*lc="_",*s1;
  setvbuf(stdout,(char *)NULL,_IONBF,0); // not buffered
  for(i=1;i<argn;i++){
    if( argv[i][0]=='-' ) { cc=argv[i][1]; }
    s1="";if(i+1<argn)s1=argv[i+1];
    switch ( cc ) {
     case 'h' : help(); break;
     case 'i' : inam =  s1;i++; break;
     case 'c' : lc   =  s1;i++; break;
     case 'l' : cs  =  atoi(s1);i++; break;
     case 's' : spc =  atoi(s1);i++; break;
     case 'v' : vvv |= atoi(s1);i++; break;
     case 'm' : mo  |= atoi(s1);i++; break;
     default: printf("# unknown option use -h for help\n");
    }
    cc=0;
  }
  if(!cs) cs =128+32; env.cs=cs;
  if(vvv)
  printf("# options are: -i %s -l %d -s %d -v %d -c %s -m %d\n",
             inam,cs,spc,vvv,lc,mo);
  // ----- read picture
  for(i=0;inam[i]!=0 && i<200;i++);	// string-length
  if(i>3 && inam[i-4]=='.'
         && inam[i-3]=='p'
         && inam[i-2]=='c'
         && inam[i-1]=='x') { readpcx(inam,&p,vvv); }
  else                      { readpgm(inam,&p,vvv); }
  { 
    p2.p = new Uchar[ p.y*p.x ]; 	// buffer
//  p2.p = (Uchar *)malloc(dy*dx);
    assert(p2.p);
    copybox(p,0,0,p.x,p.y,&p2,p.x*p.y);
  }
  // ----- count colors ------ create histogram -------
  Uint col[256];
  makehisto(p,col,plothisto);

  // ---- 0..cs = black letters, last change = Mai99
  lines.dy=0;
  for(int i2=0;i2<2;i2++)	/* iteration */
  { int j,j2,j3,w,stat=0,y2,ldy,dy,ldn=0; 
    lines.num=0;ldy=dy=0; 
    if(vvv)printf( "# scanning lines "); // alternativ aus file einlesen!!!???
    // better function for scanning line arround a letter ???
    // or define lines around known chars "eaTmM"
    // Helligkeitsschwelle? Kontrastschwelle?
    w=16;				// width of characters
    for(j2=i=y=0;y<p.y;y++){
      j=get_line3(0,p.x/2,y,y+lines.dy/2,p,cs,w);
      
      // printf("\n y= %5d pixs= %5d %5d",y,j/w,j2/w);
      if(stat==1){ // line if stat=1
        if(  j>j2){j2=j;}		/* max. schwarzanteil/zeile */
        if(2*j>j2)lines.m3[i]=y;
        if((j==0 && 6*(y-lines.m3[i])>(y-lines.m1[i])) || y+1==p.y){
          j3=lines.m3[i]-lines.m1[i];
          for(y2=lines.m1[i]+j3/8;y2<lines.m1[i]+j3/2;y2++){
            j=get_line3(0,p.x/2,y2,y2+lines.dy/2,p,cs,w);
            lines.m2[i]=y2; if(17*j>=16*j2) break;	// not the best
          } 

          /* Schiefheit bestimmen */
          for(j3=0,y2=lines.m1[i];y2<y;y2++){
            j=get_line3(p.x/2,3*p.x/4,y2+lines.dy/2,y2+3*lines.dy/4,p,cs,w);
            if(2*j>j2)j3=y2;
          } 
          ldy=0;
          if(j3!=0){  /* only long lines */
            dy+=ldy=2*(j3-lines.m3[i])/2;ldn++; }

          stat=0;j3=lines.m1[i];lines.m4[i]=y;j2=lines.m4[i]-lines.m1[i];
          lines.x0[i]=0;lines.x1[i]=p.x-1; // ??? at the moment, change it
          if(vvv&16)printf(" %2d %2d %2d  dy= %3d",
            lines.m2[i]-j3,lines.m3[i]-j3,lines.m4[i]-j3,ldy); /* end of line */
          if(i<MAXlines && j2>4)i++;
          if(i>=MAXlines){ printf("Warning: lines>MAXlines\n");break; }
          j2=0;
        }
      } else {  // empty space between lines
        if(j>w){ // noise ???
          stat=1;lines.m3[i]=lines.m2[i]=lines.m1[i]=y;j2=j;
          if(vvv&16)printf("\n line= %3d m= %4d",i,y); /* start of line */
        }
      }
      // printf(" %4d",j);
    }
    if(vvv)printf(" - lines= %d dy= %3d\n",i,dy/ldn);
    lines.num=i;
    if(i2==0)
    if(ldn) { lines.dy=dy/=ldn; } else lines.dy=dy=0;
    if(i2==1){ dy=lines.dy;
      if(vvv&32){
        for(i=0;i<lines.num;i++){ // mark lines
          for(y=lines.m1[i],x=0;x<p2.x;x++)if(x&1)put(p2,x,y+dy*x/p2.x,127,0);
          for(y=lines.m2[i],x=0;x<p2.x;x++)if(x&4)put(p2,x,y+dy*x/p2.x,127,0);
          for(y=lines.m3[i],x=0;x<p2.x;x++)if(x&4)put(p2,x,y+dy*x/p2.x,127,0);
          for(y=lines.m4[i],x=0;x<p2.x;x++)if(x&1)put(p2,x,y+dy*x/p2.x,127,0);
        }
        writepgm("out10.pgm",p2);
        for(y=0;y<p.y;y++)for(x=0;x<p.x;x++)p2.p[x+p.x*y]=p.p[x+p.x*y];
      }
    }
  }

  // ---- clear last 3 bits (flag)
  clr_bits(p,0,p.x-1,0,p.y-1);

  // ---- look for letters, put rectangular frames arround letters
  // letter = connected points near color F
  if(vvv)printf("# scanning boxes");fflush(stdout);
  for(i=0;i<lines.num;i++)	// nur erkannte Zeilen
  for(x=0+1;x<p.x-1;x++)
  for(y=lines.m3[i];2*y>lines.m2[i]+lines.m1[i];y--)	// better: rekursiv nn-pixel suchen
  {
    if( marked(p,x,y)     ) continue;	// marked
    if( pixel (p,x,y)>=cs ) continue;	// no pixel
    int x0=x,x1=x,y0=y,y1=y;	// box

    frame_nn(p,x,y,x0,x1,y0,y1,cs,AT);	// frame and mark nn-dots
    p.p[x+y*p.x]|=M1;			// mark startpoint

    if( (y1-y0+1)*(x1-x0+1)<5 )				// points arround ???
    if( 2*y1<lines.m3[i]+lines.m2[i]) continue;	// dust 
//    if( num_obj(x0-3*(x1-x0+1),
//                x1+3*(x1-x0+1),
//                y0-3*(y1-y0+1),
//                y1+3*(y1-y0+1),p,cs) < 2 ) continue;	// losting point

    numC++; sumY+=y1-y0+1; sumX+=x1-x0+1;
    // --- insert in list
    struct box *box3=new struct box
      ((struct box){x0,x1,y0,y1,x,y,0,(struct box*)NULL,(struct box*)NULL,
      '_',numC,i,
      lines.m1[i]+lines.dy*x/p.x,
      lines.m2[i]+lines.dy*x/p.x,
      lines.m3[i]+lines.dy*x/p.x,
      lines.m4[i]+lines.dy*x/p.x});
    box_app(&box1,box3);		// append to list
    for( y=lines.m1[i]+lines.dy*x/p.x;y<y0;y++)  // i-dot but no "Vo" overlap
    if( get_bw(x0+(x1-x0)/4,x1-1,y,y,p,cs,1)==1 ){ box3->y0=y;break; }
    for( y=lines.m3[i]+lines.dy*x/p.x;y>=y1;y--) 
    if( get_bw(x0+1,x1-1,y,y,p,cs,1)==1 ){ box3->y1=y;break; }
    x=x1+1; break;
  }
  env.avY=sumY/numC; env.avX=sumX/numC;
  if(vvv)printf(" %d - average X Y %d %d\n",numC,sumX/numC,sumY/numC);

  // ---- analyse boxes, find pictures (do this first!!!)
  if(vvv)printf("# detect pictures");
  for(i=0,box2=box1;box2;box2=box2->next){
    int x0=box2->x0,x1=box2->x1,y0=box2->y0,y1=box2->y1;	// box

    if( x1-x0+1>10*env.avX || y1-y0+1>10*env.avY )	/* large picture */
    { sumX-=x1-x0+1; sumY-=y1-y0+1; numC--; i++; box2->c='@'; }

    if( 4*(y1-y0+1)<env.avY || y1-y0<2)	// dots .,-_ etc.
    { sumX-=x1-x0+1; sumY-=y1-y0+1; numC--; }	// better after pictures!
  }
  if(!numC){ printf("\n no chars found - stopped\n");exit(1); }
  env.avY=sumY/numC; env.avX=sumX/numC;
  if ( spc==0 ) spc = (env.avX+20) / 4;
  if(vvv)printf(" %d - boxes %d",i,numC);
  if(vvv)printf(" - new average X Y %d %d spc %d\n",env.avX,env.avY,spc);

  // ---- analyse boxes, compare chars, compress picture ------------
  // ToDo: - error-correction only on large chars! 
  if((mo&64)){
    if(vvv)printf("# packing"); fflush(stdout);
    for(i=0,box2=box1;box2;box2=box2->next,i++);		// count boxes
    for(box2=box1;box2;box2=box2->next){
      struct box *box3,*box4=box2,*box5;
      int dist=1000,n1;	// 100% maximum
      int dx = box2->x1 - box2->x0 + 1, dx2;
      int dy = box2->y1 - box2->y0 + 1, dy2;
      if(vvv)printf("\r# packing %5d",i);
      if( dx>3 )
      for(box3=box2->next;box3;box3=box3->next)if(box2->num!=box3->num){
        dx2=box3->x1-box3->x0+1;
        dy2=box3->y1-box3->y0+1;
        if ( abs( dx2 - dx )<2 
          && abs( dy2 - dy )<2 ){
          int d=distance(p,box2->x0,box2->y0,mmax(dx,dx2),mmax(dy,dy2),
                         p,box3->x0,box3->y0,cs);
          if ( d<dist ) { dist=d; box4=box3; }	// best fit
          if ( d<1 ){
            i--;n1=box3->num;		// set all num==box2.num to box2.num
            for(box5=box1;box5;box5=box5->next)if(box5!=box2)
              if( box5->num==n1 ) box5->num=box2->num;
            // out_b2(p,box2->x0,box2->y0,dx,dy,cs,box5->x0,box5->y0);
            // printf(" dist=%d\n",d);
          }
        }
      }
      // nearest dist to box2 has box4
      //    out_b2(p,box2->x0,box2->y0,dx,dy,cs,box4->x0,box4->y0);
      //    printf(" dist=%d\n",dist); 
    }
    int k=0;
    if(vvv)printf(" %d different chars",i); fflush(stdout);
    for(box2=box1,i=0;box2;box2=box2->next){
      struct box *box3,*box4;
      int j,dist;
      for(box3=box1;box3!=box2 && box3!=NULL;box3=box3->next)
      if(box3->num==box2->num)break;
      if(box3!=box2 && box3!=NULL)continue;
      i++;
      // count number of same chars
      dist=0;box4=box2;
      for(box3=box2,j=0;box3;box3=box3->next)if(box3->num==box2->num){
        j++;
        int d=distance(p,box2->x0,box2->y0,box2->x1-box2->x0+1,box2->y1-box2->y0+1,
                       p,box3->x0,box3->y0,cs);
        if ( d>dist ) { dist=d; box4=box3; }	// worst fit
      }
      if(vvv&8){
        out_b2(p,box2->x0,box2->y0,box2->x1-box2->x0+1,box2->y1-box2->y0+1,cs,
                 box4->x0,box4->y0);
        printf(" no %d char %4d %5d times maxdist=%d\n",i,box2->num,j,dist);
      }
      // calculate mean-char (error-correction)
      // ToDo: calculate maxdist in group 
      k+=j;
  //    if(j>1)
  //    out_b(p,box2->x0,box2->y0,box2->x1-box2->x0+1,box2->y1-box2->y0+1,cs);
      if(vvv&8)
      printf(" no %d char %4d %5d times sum=%d\n",i,box2->num,j,k);   
    }
    if(vvv)printf(" ok\n");
  }


  // ---- analyse boxes, find chars ---------------------------------
  if(vvv)printf("# step 1: char recognition"); fflush(stdout);
  for(i=0,box2=box1;box2;box2=box2->next){
    struct box *box3;
    int x0=box2->x0,x1=box2->x1,
        y0=box2->y0,y1=box2->y1,	// box
        x =box2->x, y =box2->y;

    char cc=box2->c;  // only makes sence on gray-pictures!
    if(cc=='_') cc=whatletter(box2,x,y,x0,x1,y0,y1,p,cs   ,0); // 90%
//    if(cc=='_') cc=whatletter(box2,x,y,x0,x1,y0,y1,p,cs-20,0); // 60%
//    if(cc=='_') cc=whatletter(box2,x,y,x0,x1,y0,y1,p,cs+20,0); // 60%
//    if(cc=='_') cc=whatletter(box2,x,y,x0,x1,y0,y1,p,cs+40,0); // 60%
    if(vvv&8) { printf("%c\n",cc); 
                out_b(p,x0,y0,x1-x0+1,y1-y0+1,cs); }
    
    box2->c=cc; if(cc=='_')    // copy char
    for(box3=box1;box3;box3=box3->next)if(box3->num==box2->num)box3->c=cc;
    if( cc=='_' ) i++; 

//    if(cc=='.')				// points arround ???
//    if( num_obj(x0-3*(x1-x0+1),
//                x1+3*(x1-x0+1),
//                y0-3*(y1-y0+1),
//                y1+3*(y1-y0+1),p,cs) < 2 ) continue;	// losting point
     
  }
  if(vvv)printf(", %d chars unidentified\n",i);

  // ----------- write out20.pgm -----------
  if(vvv&32){
    for(box2=box1;box2;box2=box2->next){ int i;
      for(y=box2->y0;y<=box2->y1;y++)
      for(x=box2->x0;x<=box2->x1;x++){
       i=p2.p[x+y*p.x];if(i<cs)i=0;else i=192;
       if( x==box2->x0 || x==box2->x1 || y==box2->y0 || y==box2->y1 )
       { if(i<cs) i=0; else i=128+(1&(x+y))*64; } // frame
       if(box2->c=='_' || (2&(x+y))!=0) 
       p2.p[x+y*p.x]=(i&~14);  // box
      }
      p2.p[box2->x + box2->y * p.x] =(127&~3); // startpoint
    } 
    writepgm("out20.pgm",p2);
    for(y=0;y<p.y;y++)for(x=0;x<p.x;x++)p2.p[x+p.x*y]=p.p[x+p.x*y];
  }

  // ---- ------------------------------- 
#if 1
  if(vvv)printf("# step 2: try to compare unknown with known chars");
  if(!(mo&8))
  for(i=0,box2=box1;box2;box2=box2->next)if(box2->c=='_'){
    struct box *box3,*box4=box1;
    int dist=1000;	// 100% maximum
    int dx = box2->x1 - box2->x0 + 1;
    int dy = box2->y1 - box2->y0 + 1;
    int mdx,mdy;
    char bc='_';		// best fit char
    for(box3=box1;box3;box3=box3->next)if(box3->c!='_'){
      if ( abs((box3->y1-box3->m3)-(box2->y1-box2->m3))*32<=dy 
       &&  abs((box3->y0-box3->m2)-(box2->y0-box2->m2))*32<=dy ) // to hard?
      if ( abs( box3->x1-box3->x0+1 - dx )<3 
        && abs( box3->y1-box3->y0+1 - dy )<3  ){
        mdx = box3->x1 - box3->x0 + 1; if(dx>mdx)mdx=dx;
        mdy = box3->y1 - box3->y0 + 1; if(dy>mdy)mdy=dy;
        int d=distance(p,box2->x0,box2->y0,mdx,mdy,
                       p,box3->x0,box3->y0,cs);
        if ( d<dist ) { dist=d; bc=box3->c; box4=box3; }
      }
    }
    {
      if(dist<10) box2->c=bc;	// better 20 as option???
				//  => better max distance('e','e') ???
      if( 0*dist<50 )if(vvv){
        printf("\n# best fit for line %2d was %c %3d%% %d",box2->line,bc,dist,i);
//        out_b(p,box2->x0,box2->y0,dx,dy,cs);
//        out_b(p,box4->x0,box4->y0,dx,dy,cs);
      }
      i++;
    }
  }
  if(vvv)printf(" - found %d\n",i);
#endif

  // ---- divide overlapping chars which !in_str(c,"_,.:;");
  // completely changed at Mar2000
  //
  if(vvv)printf("# step 3: try to divide unknown chars");fflush(stdout);
  if(!(mo&16))
  for(box2=box1;box2;box2=box2->next)
  if(box2->c=='_' && box2->x1-box2->x0>5 && box2->y1-box2->y0>4){
      struct box *box3; 
      char c1,c2,*s1="_.,'!;";		// not accepted chars
      int x0,x1,y0,y1,x=0;
      x0=box2->x0; x1=box2->x1;
      y0=box2->y0; y1=box2->y1;
      if(vvv&32)out_b(p,x0,y0,x1-x0+1,y1-y0+1,cs);
      {	// doublet = 2 letters
        int i,j,m,m1,m2,m3,i1,i2,i3;
        m1=m2=m3=0; i1=i2=i3=0; // searching minima m1 m2 m3
        for(i=0;i<(x1-x0)/2-2;i++){
          for(m=0,j=y0;j<=y1;j++) m+=((pixel(p,(x1+x0)/2+i,j)<cs)?0:1); // using gray
          if(m>m1){ m3=m2;m2=m1;m1=m;i3=i2;i2=i1;i1=i; } else
          if(m>m2){ m3=m2;m2=m;      i3=i2;i2=i;       } else
          if(m>m3){ m3=m;            i3=i;             }
          if(i==0) continue;
          for(m=0,j=y0;j<=y1;j++) m+=((pixel(p,(x1+x0)/2-i,j)<cs)?0:1); // using gray
          if(m>m1){ m3=m2;m2=m1;m1=m;i3=i2;i2=i1;i1=-i; } else
          if(m>m2){ m3=m2;m2=m;      i3=i2;i2=-i;       } else
          if(m>m3){ m3=m;            i3=-i;             }
        }
        i1+=(x1+x0)/2;
        i2+=(x1+x0)/2;
        i3+=(x1+x0)/2;
        {
          x=i1;
          c1=whatletter(box2,x0 ,y0,x0 ,x  ,y0,y1,p,cs,0); // unknown startpos!
          c2=whatletter(box2,x+1,y0,x+1,x1 ,y0,y1,p,cs,0); // unknown startpos!
          if( in_str(c1,s1)  || in_str(c2,s1) ) x=0;
        }
        if(vvv&32)printf(" i1,i2,i3,x c12 =%d %d %d %d %c %c\n",i1-x0,i2-x0,i3-x0,x-x0,c1,c2);
        if(!x){
          x=i2;
          c1=whatletter(box2,x0 ,y0,x0 ,x  ,y0,y1,p,cs,0); // unknown startpos!
          c2=whatletter(box2,x+1,y0,x+1,x1 ,y0,y1,p,cs,0); // unknown startpos!
          if( in_str(c1,s1)  || in_str(c2,s1) ) x=0;
        }
        if(vvv&32)printf(" i1,i2,i3,x c12 =%d %d %d %d %c %c\n",i1-x0,i2-x0,i3-x0,x-x0,c1,c2);
        if(!x){
          x=i3;
          c1=whatletter(box2,x0 ,y0,x0 ,x  ,y0,y1,p,cs,0); // unknown startpos!
          c2=whatletter(box2,x+1,y0,x+1,x1 ,y0,y1,p,cs,0); // unknown startpos!
          if( in_str(c1,s1)  || in_str(c2,s1) ) x=0;
        }
        if(vvv&32)printf(" i1,i2,i3,x c12 =%d %d %d %d %c %c\n",i1-x0,i2-x0,i3-x0,x-x0,c1,c2);
      }
      if(x>x0 && x<x1){			// seperate first
        // --- insert in list
        box3=new struct box((struct box)*box2);
        box3->x1=x1=x;   box3->c=c1;
        box2->x0=   x+1; box2->c=c2;
        box_ins_before(box2,box3); numC++;continue; 
      }
  }
  if(vvv)printf(", numC %d\n",numC); 


  // ---- list output ---- for debugging
  if(vvv&6){
    for(i=0,box2=box1;box2;box2=box2->next,i++)
    if( strc(box2->c,lc) ){
      printf("# list chape %3d x=%4d %4d d=%3d %3d h=%d o=%d dots=%d %c\n",
        i,box2->x0,box2->y0,box2->x1-box2->x0+1,box2->y1-box2->y0+1,
        num_hole(box2->x0,box2->x1,box2->y0,box2->y1,p,cs),
        num_obj (box2->x0,box2->x1,box2->y0,box2->y1,p,cs),
        box2->dots,  box2->c );
      if( vvv&4 ){   
        out_b(p,box2->x0,box2->y0,box2->x1-box2->x0+1,box2->y1-box2->y0+1,cs);
      }
    } 
  }

  // ---- insert spaces ----
  for(i=0,box2=box1;box2;box2=box2->next,i++){
    char cc=0;
    if(box2->pre){
      if(box2->line!=box2->pre->line ) cc='\n';      // NL
      if(box2->x0 > box2->pre->x1)
      if(box2->x0 - box2->pre->x1 > spc) cc=' ';     // SPC
      if(cc){
        struct box *box3=new struct box ((struct box){
          box2->pre->x1+2,box2->x0-2,box2->y0,box2->y1,
          box2->x0-1,box2->y0,0,(struct box*)NULL,(struct box*)NULL,
          cc,0,box2->pre->line,0,0,0,0});
        box_ins_before(box2,box3);
      }
    }
  }

  // ---- proof Il1 by context view ----
  // context: seperator, number, vokal, nonvokal, upper char ????
  if(vvv)printf("# step 4: context proof");
  for(i=0,box2=box1->next;box2;box2=box2->next,i++){
    if(box2->c=='I' || box2->c=='l' || box2->c=='1'){
      if(box2->pre) if(box2->pre->c==' ' || box2->pre->c=='\n')
      if(box2->next && box2->next->c=='n') box2->c='l';
    }
    if(box2->pre->c==' ' && box2->c=='.') box_del(box2->pre);
  }
  if(vvv)printf("\n");

  // ---- ASCII output
  for(i=0,box2=box1;box2;box2=box2->next,i++){
    printf("%c",box2->c);
  }
  printf("\n");

  // ---- frame-size-histogramm
  // ---- (my own defined) distance between letters
  // ---- write internal picture of textsite
  // ----------- write out30.pgm -----------
  if(vvv&32){
    for(box2=box1;box2;box2=box2->next){ int i;
      for(y=box2->y0;y<=box2->y1;y++)
      for(x=box2->x0;x<=box2->x1;x++){
       i=p2.p[x+y*p.x];if(i<cs)i=0;else i=192;
       if( x==box2->x0 || x==box2->x1 || y==box2->y0 || y==box2->y1 )
       { if(i<cs) i=0; else i=128+(1&(x+y))*64; } // frame
       if(box2->c=='_' || (2&(x+y))!=0) 
       p2.p[x+y*p.x]=(i&~14);  // box
      }
      p2.p[box2->x + box2->y * p.x] =(127&~3); // startpoint
    } 
    writepgm("out30.pgm",p2);
    for(y=0;y<p.y;y++)for(x=0;x<p.x;x++)p2.p[x+p.x*y]=p.p[x+p.x*y];
  }
  
  delete p.p;
  delete p2.p;
  while(box1) { box2=box1->next; delete box1; box1=box2; } 
}
/*
 -----------------------------------------------------------------
       #   v  
       #   v     mark connected points via fifo-stack
       ### *<<   and 3bit direction code per pixel,
       # # ^ ^   should be better for overlapping letters
       ### ^<<
 --------------------- point connections ----------------------
 searching next nearest point  
     /----\
     |    |
   ^ | ## |
   | | ## |
   | |  | |
   | \--/ |
   \------/
-------------------------------------------------------------
*/